#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include "mpegsnap.h"
#include "atltime.h"
#include "atlcomtime.h"

// CPreviewDialog dialog

class CPreviewDialog : public CDialog
{
	DECLARE_DYNAMIC(CPreviewDialog)

public:
	CPreviewDialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~CPreviewDialog();

// Dialog Data
	enum { IDD = IDD_DIALOG_PREVIEW };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
  TJobEntry m_structJobs[100];
  int m_nNumberOfJobs;
private:
  int m_nMagnify;
  // Laufzeit des Clips
  CString m_sRuntime;
  // Position im Film
  CString m_sPosition;
  CPVRFile * m_pPVRFile;
	sFileDescription * m_sFD;
  CSliderCtrl m_wndSliderTime;
  HBITMAP m_hBitmap;
  afx_msg void OnNMReleasedcaptureSliderTime(NMHDR *pNMHDR, LRESULT *pResult);

public:
  bool Init(CPVRFile * pPVRFile);
  virtual BOOL OnInitDialog(void);

private:
  __int64 m_i64BeginPos;
  __int64 m_i64CurPos;
  bool m_bWheelTimer;
  int  m_nWheelCount;
  CString m_sEndTime;
  CString m_sBeginTime;
public:
  afx_msg void OnBnClickedButton30sekBack();
  afx_msg void OnBnClickedButton5secBack();
  afx_msg void OnBnClickedButton1secBack();
  afx_msg void OnBnClickedButton1secFor();
  afx_msg void OnBnClickedButton5secFor();
  afx_msg void OnBnClickedButton30secFor();
  afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
  afx_msg void OnTimer(UINT nIDEvent);
  afx_msg void OnBnClickedButtonSetBegin();
  afx_msg void OnBnClickedButtonSetEnd();
  CString m_sClipName;
  BOOL m_bRipStreamRaw;
  BOOL m_bRipAudioRaw;
  CStatic m_wndPreview;
  afx_msg void OnBnClickedButtonAddJob();
  afx_msg void OnBnClickedButton5minBack();
  afx_msg void OnBnClickedButton5minFor();
  afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
private:
  // Beginnzeit
  DWORD m_dwBeginTime;
  // End Zeit
  DWORD m_dwEndTime;
public:
//  afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
  afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
// Magnifies search range
  CButton m_wndMagnify;
  afx_msg void OnBnClickedCheckMagnify();
  int OnBnClickedButtonX(int nFactor, int nIndex);
  afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
  afx_msg void OnBnClickedButtonGoto();
  // Goto Zeit
  double m_dGotoTime;
  afx_msg void OnBnClickedOk();
  COleDateTime m_oleRealTime;
};
