// WinPVRDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "WinPVR.h"
#include "general.h"
#include "fat.h"
#include "ibits.h"
#include "obits.h"
#include "mpeg.h"
#include "WinPVRDlg.h"
#include "DlgFileName.h"
#include "ReaderThread.h"
#include "PreviewDialog.h"
#include "DlgOptions.h"
#include <direct.h>
#include <mmsystem.h>
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_sRipperVersion;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
  // WinPVR Version
  CString m_sWinPVRVersion;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
, m_sWinPVRVersion(_T(""))
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_sRipperVersion = "PVRRipper Version:";
	//}}AFX_DATA_INIT
	m_sWinPVRVersion = "WinPVR Version ";
  m_sWinPVRVersion += PVRVERSION;
  m_sWinPVRVersion += " beta";
#ifdef _DEBUG
  m_sWinPVRVersion += " Debug build";
#endif
	m_sRipperVersion += VERSION;
}

BOOL CWinPVRDlg::DestroyWindow() 
{
	delete g_pfatFAT;
	delete m_pDrive;
	if (pfsLog != NULL)
	{
		pfsLog->close ();
		delete pfsLog;	
	}
	return CDialog::DestroyWindow();
}


void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(CAboutDlg)
  DDX_Text(pDX, IDC_STATIC_PVRRIPPER_VERSION, m_sRipperVersion);
  //}}AFX_DATA_MAP
  DDX_Text(pDX, IDC_WINPVR_VERSION, m_sWinPVRVersion);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinPVRDlg Dialogfeld

CWinPVRDlg::CWinPVRDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinPVRDlg::IDD, pParent)
  , m_bPatchSeqHeader(FALSE)
{
	//{{AFX_DATA_INIT(CWinPVRDlg)
	m_bRipAudio = TRUE;
	m_bRipVideo = TRUE;
	m_sDrive = _T("");
	m_sAudio = _T("");
	m_sVideo = _T("");
	m_dwRipzeit = 0;
	m_dwOffset = 0;
	m_sEndPTS = _T("");
	m_sStartPTS = _T("");
	m_sVideoZeit = _T("");
	m_sAudioZeit = _T("");
	m_sSizeAudio = _T("");
	m_sSizeVideo = _T("");
	m_sOutputDir = _T("");
	m_bPlaySound = FALSE;
	m_bWriteLogFile = FALSE;
	m_sBeginnZeit = _T("");
	m_sEndZeit = _T("");
	m_bRipAudioRaw = FALSE;
  m_bRipVideoRaw = FALSE;
	m_sJobNumber = _T("");
	m_bMakeBackup = FALSE;
	m_sDriveCapacity = _T("");
	m_sDriveType = _T("");
	m_sFreespace = _T("");
  m_sJobSize = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	g_pfatFAT = NULL;
	m_pDrive = NULL;
	m_nNumberOfJobs = 0;
	m_bJobControl = FALSE;
	m_bRestoreBackup = FALSE;
}

void CWinPVRDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  int i;
  double fJobsize (0);
  m_sJobNumber.Format ("%d", m_nNumberOfJobs);
  for (i = 0; i < m_nNumberOfJobs; i++)
  {
    fJobsize += m_structJobs[i].fSizeInGB;
  }
  m_sJobSize.Format ("Size: %.02f GB", fJobsize);



  //{{AFX_DATA_MAP(CWinPVRDlg)
  DDX_Control(pDX, IDC_BUTTON_SAMPLE, m_wndButtonSample);
  DDX_Control(pDX, IDC_BUTTON_OUTPUT_DIR, m_wndButtonOutputDir);
  DDX_Control(pDX, IDC_BUTTON_DIR, m_wndButtonDir);
  DDX_Control(pDX, IDOK, m_wndRip);
  DDX_Control(pDX, IDC_PROGRESS_AUDIO, m_wndAudio);
  DDX_Control(pDX, IDC_PROGRESS_VIDEO, m_wndVideo);
  DDX_Control(pDX, IDC_LIST_CONTENTS, m_wndContents);
  DDX_Control(pDX, IDC_COMBO_DRIVE, m_cbDrive);
  DDX_Check(pDX, IDC_CHECK_RIP_AUDIO, m_bRipAudio);
  DDX_Check(pDX, IDC_CHECK_RIP_VIDEO, m_bRipVideo);
  DDX_CBString(pDX, IDC_COMBO_DRIVE, m_sDrive);
  DDX_Text(pDX, IDC_STATIC_AUDIO, m_sAudio);
  DDX_Text(pDX, IDC_STATIC_VIDEO, m_sVideo);
  DDX_Text(pDX, IDC_EDIT_RIPZEIT, m_dwRipzeit);
  DDX_Text(pDX, IDC_EDIT_OFFSET, m_dwOffset);
  DDX_Text(pDX, IDC_STATIC_END_PTS, m_sEndPTS);
  DDX_Text(pDX, IDC_STATIC_START_PTS, m_sStartPTS);
  DDX_Text(pDX, IDC_STATIC_VIDEO_ZEIT, m_sVideoZeit);
  DDX_Text(pDX, IDC_STATIC_AUDIO_ZEIT, m_sAudioZeit);
  DDX_Text(pDX, IDC_STATIC_SIZE_AUDIO, m_sSizeAudio);
  DDX_Text(pDX, IDC_STATIC_SIZE_VIDEO, m_sSizeVideo);
  DDX_Text(pDX, IDC_EDIT_OUTPUT_DIR, m_sOutputDir);
  DDX_Check(pDX, IDC_CHECK_PLAY_SOUND, m_bPlaySound);
  DDX_Check(pDX, IDC_CHECK_LOG, m_bWriteLogFile);
  DDX_Text(pDX, IDC_EDIT_BEGIN_ZEIT, m_sBeginnZeit);
  DDX_Text(pDX, IDC_EDIT_END_ZEIT, m_sEndZeit);
  DDX_Check(pDX, IDC_CHECK_AUDIO_RAW, m_bRipAudioRaw);
  DDX_Check(pDX, IDC_CHECK_VIDEO_RAW, m_bRipVideoRaw);
  DDX_Text(pDX, IDC_STATIC_JOBNR, m_sJobNumber);
  DDX_Check(pDX, IDC_CHECK_MAKE_BACKUP, m_bMakeBackup);
  DDX_Text(pDX, IDC_STATIC_CAPACITY, m_sDriveCapacity);
  DDX_Text(pDX, IDC_STATIC_DRIVENAME, m_sDriveType);
  DDX_Text(pDX, IDC_STATIC_FREESPACE, m_sFreespace);
  DDX_Text(pDX, IDC_STATIC_JOBSIZE, m_sJobSize);
  //}}AFX_DATA_MAP
  BOOL bFirmware;
  bFirmware = g_bFirmware;
  DDX_Check(pDX, IDC_CHECK_FIRMWARE190, bFirmware);
  g_bFirmware = (bFirmware != 0);
  DDX_Check(pDX, IDC_CHECK_PATCH_SEQ_HEADER, m_bPatchSeqHeader);
}

BEGIN_MESSAGE_MAP(CWinPVRDlg, CDialog)
	//{{AFX_MSG_MAP(CWinPVRDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_DIR, OnButtonDir)
	ON_NOTIFY(NM_CLICK, IDC_LIST_CONTENTS, OnClickListContents)
	ON_BN_CLICKED(IDOK, OnRipStream)
	ON_EN_KILLFOCUS(IDC_EDIT_RIPZEIT, OnKillfocusEditRipzeit)
	ON_EN_KILLFOCUS(IDC_EDIT_OFFSET, OnKillfocusEditOffset)
	ON_EN_KILLFOCUS(IDC_EDIT_BEGIN_ZEIT, OnKillfocusEditBeginnZeit)
	ON_EN_KILLFOCUS(IDC_EDIT_END_ZEIT, OnKillfocusEditEndeZeit)
	ON_EN_SETFOCUS(IDC_EDIT_END_ZEIT, SetfocusEditEndZeit)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_SAMPLE, OnButtonSample)
	ON_BN_CLICKED(IDC_BUTTON_RESTORE_BACKUP, OnButtonRestore)
	ON_BN_CLICKED(IDC_BUTTON_ADD_JOB, OnButtonAddJob)
	ON_BN_CLICKED(IDC_BUTTON_DEL_JOBS, OnButtonDelJobs)
	ON_BN_CLICKED(IDC_BUTTON_OUTPUT_DIR, OnButtonOutputDir)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_CONTENTS, OnDblclkListContents)
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_MENU_TITELAENDERN, OnMenuTitelaendern)
	ON_COMMAND(ID_ADDTORAWAUDIOLIST, OnAddtorawaudiolist)
	ON_BN_CLICKED(IDC_BUTTON_SCAN, OnButtonScan)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_JOBS, OnButtonSaveJobs)
	ON_NOTIFY(NM_RCLICK, IDC_LIST_CONTENTS, OnRclickListContents)
	ON_COMMAND(ID_MENU_RIP, OnRipStream)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_JOBS, OnButtonLoadJobs)
	//}}AFX_MSG_MAP
	ON_NOTIFY_EX( TTN_NEEDTEXT, 0, OnToolTipNotify )
  ON_BN_CLICKED(IDC_CHECK_FIRMWARE190, OnBnClickedCheckFirmware190)
  ON_COMMAND(ID_TITEL_PREVIEW, OnTitelPreview)
//  ON_WM_MOUSEWHEEL()
ON_BN_CLICKED(ID_BUTTON_PATCH_FILE, OnBnClickedButtonPatchFile)
ON_BN_CLICKED(ID_BUTTON_OPTIONS, OnBnClickedButtonOptions)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinPVRDlg Nachrichten-Handler

BOOL CWinPVRDlg::OnInitDialog()
{
	int i;
	CString s;
	DWORD dwSectorsPerCluster;     // sectors per cluster
	DWORD dwBytesPerSector;        // bytes per sector
	DWORD dwNumberOfFreeClusters;  // number of free clusters
	DWORD dwTotalNumberOfClusters;  // total number of clusters
	DWORD dwListCtrlStyle;		   // Stil der Kontrolle
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	LoadSettings ();
	
	// lesen der Driveinfo
	for (i = 'C'; i < 'Z'; i++)
	{
		s.Format ("%c:\\", i);
		UINT udt = GetDriveType (s);
		if (udt == DRIVE_FIXED)
		{
			GetDiskFreeSpace (s, &dwSectorsPerCluster, &dwBytesPerSector,
				&dwNumberOfFreeClusters, &dwTotalNumberOfClusters);
			if (dwBytesPerSector == 0)
			{
				m_cbDrive.AddString (s);
				m_cbDrive.SelectString (0, s);
			}
		}
 
	}
	// erstellen der Listenansicht
	m_wndContents.InsertColumn (0, "No.", LVCFMT_RIGHT, m_wndContents.GetStringWidth("   ") + 15);
	m_wndContents.InsertColumn (1, "Channel Name         ", LVCFMT_LEFT, 100, 1);
	m_wndContents.InsertColumn (2, "Clip Name            ", LVCFMT_LEFT, 250, 2);
	m_wndContents.InsertColumn (3, "Length / Max Size    ", LVCFMT_LEFT, 130, 3);
	m_wndContents.InsertColumn (4, "Date                 ", LVCFMT_LEFT, 90, 4);
	m_wndContents.InsertColumn (5, "Time                 ", LVCFMT_LEFT, 55, 5);
	dwListCtrlStyle = m_wndContents.GetExtendedStyle ();
	m_wndContents.SetExtendedStyle (dwListCtrlStyle | LVS_EX_FULLROWSELECT);
	if (m_cbDrive.GetCount ())
		OnButtonDir ();
	m_wndAudio.ShowWindow (SW_HIDE);
	m_wndVideo.ShowWindow (SW_HIDE);
	// Button frben
	// m_wndFolderBitmap.LoadBitmap (IDB_BITMAP_FOLDER);
	CButton * pButt = (CButton *) GetDlgItem (IDC_BUTTON_OUTPUT_DIR);
	pButt->SetBitmap ((HBITMAP) m_wndFolderBitmap);
	m_bReaderReady = true;
	_chdir (m_sOutputDir);
	EnableToolTips ();
	m_nNumberOfJobs = 0;  // Jobanzahl auf 0 setzen
	s = "WinPVR ";
  s += PVRVERSION;
#ifdef _DEBUG
  s += " Debug";
#else
  s += " Release";
#endif
  SetWindowText (s);

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CWinPVRDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CWinPVRDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CWinPVRDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


// Dir holen
void CWinPVRDlg::OnButtonDir() 
{
	bool bResult;
	int i (0);
	
	CString sDrive, sChannel, sClip, sTemp, sTime;
	string m_cDrivename;

	UpdateData (TRUE);
	m_wndContents.DeleteAllItems ();
	// wenn ein Drive vorhanden und gewhlt ist
	if (m_sDrive.Find (":") != -1)
  {
		OpenLog ("DIR");
		sDrive = m_sDrive.Left (m_sDrive.Find (":")+1);
		sDrive = "\\\\.\\" + sDrive;
		m_cDrivename = sDrive;
  }
  else
  {
#ifdef _DEBUG
		OpenLog ("DIR");
		m_cDrivename = "REC";
#else
    return;
#endif
  }

	if (!g_pfatFAT)	g_pfatFAT = new CFAT(m_cDrivename, bResult);
	if (!m_pDrive)
	{
		m_pDrive = new CPVRDrive(m_cDrivename);
		m_sDriveType = m_pDrive->GetDriveType ();
		if (m_sDriveType.Find ("   ") != -1)
		{
			m_sDriveType = m_sDriveType.Left (m_sDriveType.Find ("   "));
		}
		else
		{
			m_sDriveType = "No Drive";
		}
		m_sFreespace.Format ("Free: %.1f GB", (double) m_pDrive->FreeClusters () / 10);
		m_sDriveCapacity.Format ("Capacity: %.1f GB", (double) (m_pDrive->UsedClusters () + m_pDrive->FreeClusters ()) / 10);
		UpdateData (FALSE);
	}
  else // hole driverec ....
  {
		m_sDriveType = m_pDrive->GetDriveType ();
		if (m_sDriveType.Find ("   ") != -1)
		{
			m_sDriveType = m_sDriveType.Left (m_sDriveType.Find ("   "));
		}
		else
		{
			m_sDriveType = "No Drive";
		}
		m_sFreespace.Format ("Free: %.1f GB", (double) m_pDrive->FreeClusters () / 10);
		m_sDriveCapacity.Format ("Capacity: %.1f GB", (double) (m_pDrive->UsedClusters () + m_pDrive->FreeClusters ()) / 10);
		UpdateData (FALSE);
  }
	// Holen der Daten der Filmchen
	for (i = 0; i < m_pDrive->FilesCount (); i++)
	{
		m_pPVRFile = m_pDrive->File (i);
		m_pFD = m_pPVRFile->GetFileDescription ();
#ifdef _DEBUG
		m_pPVRFile->dump_file ();
#endif

		sTemp.Format ("%02d", i+1);
		m_wndContents.AddItem (i, 0, sTemp);
		
		sChannel = m_pFD->cStationName;
		m_wndContents.AddItem (i, 1, sChannel);
		
		sClip= m_pFD->cClipName;
		m_wndContents.AddItem (i, 2, sClip);

		sTime.Format ("%02d:%02d:%02d / %1.1f GB", m_pFD->iLengthHours, m_pFD->iLengthMinutes, 
			m_pFD->iLengthSeconds, (double) (m_pFD->iAudioClusterCount + m_pFD->iVideoClusterCount) / 10.0);
		m_wndContents.AddItem (i, 3, sTime);

		sTemp.Format ("%02d.%02d.%04d", m_pFD->iRecordDay, m_pFD->iRecordMonth, m_pFD->iRecordYear);
		m_wndContents.AddItem (i, 4, sTemp);
		
		sTemp.Format ("%02d:%02d", m_pFD->iRecordHour, m_pFD->iRecordMinute);
		m_wndContents.AddItem (i, 5, sTemp);

	}
	CloseLog ();
  if (m_dwaCheckSums.GetCount () == 0)
  {
    DWORD dw;
	  for (i = 0; i < m_pDrive->FilesCount (); i++)
	  {
      dw = CheckSum (i);
      m_dwaCheckSums.Add (dw);
    }
  }
}

BOOL CWinPVRDlg::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    UINT nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)
    {
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);
        if(nID)
        {
            pTTT->lpszText = MAKEINTRESOURCE(nID);
            pTTT->hinst = AfxGetResourceHandle();
            return(TRUE);
        }
    }
    return(FALSE);
}



void CWinPVRDlg::OnClickListContents(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int nIndex, i;
	DWORD dw, dwTemp;
	CString s;
	UpdateData (TRUE);

	m_dwOffset = 0;

	// Daten des gewhlten Eintrages holen
	nIndex = m_wndContents.GetSelectionMark ();
	if (nIndex == -1) return;
	m_pPVRFile = m_pDrive->File (nIndex);
	m_pFD = m_pPVRFile->GetFileDescription ();
	dw = m_pFD->iLengthHours * 3600 + m_pFD->iLengthMinutes * 60 + m_pFD->iLengthSeconds;
	m_dwRipzeit = dw;
	m_sBeginnZeit.Format ("%d:%02d:%02d.%.2f", m_dwOffset / 3600, ((int)m_dwOffset % 3600) / 60, ((int)m_dwOffset % 60), m_dwOffset - (int) m_dwOffset);
  dwTemp = (DWORD) (m_dwRipzeit + m_dwOffset);
	m_sEndZeit.Format("%d:%02d:%02d.%02d", dwTemp / 3600, (dwTemp % 3600) / 60, (dwTemp % 60),
   (int) ((m_dwRipzeit + m_dwOffset) - (int) (m_dwRipzeit + m_dwOffset) * 100)%100);
	s = m_wndContents.GetItemChannel (nIndex);
	// Tabelle durchsuchen, ob Sender Audio-Rohdaten haben muss
	for (i = 0; i < m_saRawAudio.GetSize (); i++)
	{
		if (m_saRawAudio.GetAt (i) == s.Left (m_saRawAudio.GetAt (i).GetLength ()))
		{
			m_bRipAudioRaw = TRUE;
			break;
		}
	}
	if (i == m_saRawAudio.GetSize ()) m_bRipAudioRaw = FALSE;
	UpdateData (FALSE);

	
	OnKillfocusEditOffset ();
	*pResult = 0;
}

void CWinPVRDlg::OnRipStream() 
{
	int nIndex;
  UpdateData ();
	nIndex = m_wndContents.GetSelectionMark ();
	if (nIndex == -1 && !m_nNumberOfJobs && !m_bJobControl) return;

	if (!m_nNumberOfJobs && !m_bJobControl) 
	{
		RipStream ();  // einfacher Job
	}
	else
	{
		// Ein Job aus der Jobliste
		m_wndContents.SetSelectionMark (m_structJobs[m_nNumberOfJobs-1].nIndex);
		m_wndContents.SetItemState(m_structJobs[m_nNumberOfJobs-1].nIndex, LVIS_SELECTED, LVIS_SELECTED);
		m_dwRipzeit = m_structJobs[m_nNumberOfJobs-1].dwRipzeit;
		m_dwOffset  = m_structJobs[m_nNumberOfJobs-1].dwOffset;
		m_bRipAudioRaw = m_structJobs[m_nNumberOfJobs-1].bRipAudioRaw;
    if (m_bRipVideoRaw) m_bRipAudioRaw = TRUE;
		m_bMakeBackup = m_structJobs[m_nNumberOfJobs-1].bMakeBackup;
		m_bRipAudio = m_structJobs[m_nNumberOfJobs-1].bRipAudio;
		m_bRipVideo = m_structJobs[m_nNumberOfJobs-1].bRipVideo;
		UpdateData (FALSE);
		OnKillfocusEditRipzeit ();
		RipStream ();
		m_nNumberOfJobs--;
	}

}


void CWinPVRDlg::RipStream()
{
	int nIndex;
	sFileDescription * sFD;
	DWORD dwLength;

	CWnd * pWnd;
	int i;

	for (i = IDC_FIRST_ITEM; i < IDC_LAST_ITEM; i++)
	{
		pWnd = GetDlgItem (i);
		if (pWnd != NULL)
			pWnd->EnableWindow (FALSE);
	}
	UpdateData (TRUE);
	nIndex = m_wndContents.GetSelectionMark ();
	if (nIndex == -1) return;
	m_pPVRFile = m_pDrive->File (nIndex);
	sFD = m_pPVRFile->GetFileDescription ();
	
	// Lngenwerte prfen
	dwLength = sFD->iLengthHours * 3600 + sFD->iLengthMinutes * 60 + sFD->iLengthSeconds;
	if (m_dwOffset > dwLength) 
	{
		MessageBox ("wrong offset", "ERROR from RipStream");
		return;
	}
	if (m_dwOffset + m_dwRipzeit > dwLength) 
	{
		m_dwRipzeit = dwLength - m_dwOffset;
		UpdateData (FALSE);
	}
	
	OpenLog (sFD->cClipName);
	m_pPVRFile->m_pInfoAudio = &m_InfoAudio;
	m_pPVRFile->m_pInfoVideo = &m_InfoVideo;

  m_InfoVideo.m_bPatchSeqHeader	= (m_bPatchSeqHeader == TRUE);
	m_InfoAudio.m_bProcess = (m_bRipAudio == TRUE);
	m_InfoAudio.m_bRipRaw = (m_bRipAudioRaw == TRUE);
	m_InfoVideo.m_bMakeBackup = (m_bMakeBackup == TRUE);
	m_InfoVideo.m_bRipRaw = (m_bRipVideoRaw == TRUE);
	m_InfoVideo.m_bProcess = (m_bRipVideo == TRUE);
//	m_InfoVideo.m_bMakeBackup = (m_bSplitRecording == TRUE);
	m_InfoAudio.m_bMakeBackup = (m_bRestoreBackup == TRUE);
	m_bRestoreBackup = FALSE;
	m_sSizeAudio = "0 MB";
	m_sSizeVideo = "0 MB";
	m_InfoAudio.m_nFileSize = 0;
	m_InfoVideo.m_nFileSize = 0;
	m_sAudioZeit.Empty ();
	m_sVideoZeit.Empty ();
	m_wndAudio.SetPos (0);
	m_wndVideo.SetPos (0);
	m_InfoAudio.m_bRunning = false;
	m_InfoVideo.m_bRunning = false;
	m_pcrThread = new (CReaderThread);
	m_pcrThread->Init (m_pPVRFile, m_dwRipzeit ,m_dwOffset, m_bWriteLogFile);
	m_bCancel = false;
	m_bReaderReady = false;
	m_pcrThread->m_pbReady = &m_bReaderReady;
	m_pcrThread->m_pbCancel = &m_bCancel;
	m_pcrThread->CreateThread ();
	m_pcrThread->m_bAutoDelete = true;
	// Bei Job den Namen kopieren
	if (m_bJobControl)
	{
		m_pPVRFile->SetFilename (m_structJobs[m_nNumberOfJobs-1].sFilename);
		m_wndContents.SetItemTrackTitle (nIndex, m_structJobs[m_nNumberOfJobs-1].sFilename);
	}
	else
	{
		m_pPVRFile->SetFilename (NULL);
	}

	if (m_bRipAudio) m_wndAudio.ShowWindow (SW_NORMAL);
	if (m_bRipVideo) m_wndVideo.ShowWindow (SW_NORMAL);
	
	// Alle Fenster deaktivieren um Inkonsistenzen zu vermeiden
	m_wndRip.EnableWindow (false);
	m_wndButtonDir.EnableWindow (false);
	m_wndButtonOutputDir.EnableWindow (false);
	m_wndContents.EnableWindow (false);
	m_wndButtonSample.EnableWindow (false);

	UpdateData (FALSE);
	SetTimer (1, 250, NULL);

}



void CWinPVRDlg::OnKillfocusEditRipzeit() 
{
	UpdateData ();
  DWORD dw;
	// Anfangs und Endzeit anpassen
  dw = (DWORD) m_dwOffset;
	m_sBeginnZeit.Format ("%d:%02d:%02d.%02d", dw / 3600, (dw % 3600) / 60, (dw % 60), (int) (m_dwOffset * 100) %100);
  dw = (DWORD) (m_dwRipzeit + m_dwOffset);
	m_sEndZeit.Format("%d:%02d:%02d.%02d", dw / 3600, (dw % 3600) / 60, (dw % 60), (int) ((m_dwRipzeit + m_dwOffset) * 100) % 100);
	UpdateData (FALSE);
}

void CWinPVRDlg::OnKillfocusEditBeginnZeit() 
{
	DWORD dwStunde, dwMinute, dwSecs , dwMS;
  double dSecs;

	UpdateData ();
	if (m_sBeginnZeit.Find (":") != -1)
	{
		// Falls in der Form h:mm:ss eingegeben
		sscanf (m_sBeginnZeit, "%d:%02d:%02d.%02d", &dwStunde, &dwMinute, &dwSecs, &dwMS);
    dSecs = dwSecs + (double) dwMS / 100;
		m_dwOffset = dwStunde * 3600 + dwMinute * 60 + dSecs;
	}
	else
	{
		// falls in der Form hmmss eingegeben
    dSecs = atof (m_sBeginnZeit);
    dwStunde = (DWORD) (dSecs * 100);
		m_dwOffset = dwStunde % 100;
		dwStunde /= 100;
		m_dwOffset += (dwStunde % 100) * 100;
		dwStunde /= 100;
		m_dwOffset += (dwStunde % 100) * 6000;
		dwStunde /= 100;
		m_dwOffset += (dwStunde % 100) * 360000;
    m_dwOffset /= 100;
	}
	UpdateData (FALSE);
	OnKillfocusEditOffset ();
}

void CWinPVRDlg::OnKillfocusEditEndeZeit() 
{
	UpdateData ();
	DWORD dwStunde, dwMinute, dwSecs, dwMS;
  double dSecs;
	// siehe OnKillfocusEditBeginnZeit
	if (m_sEndZeit.Find (":") != -1)
	{
		sscanf (m_sEndZeit, "%d:%02d:%02d.%02d", &dwStunde, &dwMinute, &dwSecs, &dwMS);
    dSecs = dwSecs + (double) dwMS / 100;
		m_dwRipzeit = dwStunde * 3600 + dwMinute * 60 + dSecs;
	}
	else
	{
		sscanf (m_sEndZeit, "%f", &dSecs);
    dSecs = atof (m_sEndZeit);
    dwStunde = (DWORD) (dSecs * 100);
		m_dwRipzeit = dwStunde % 100;
		dwStunde /= 100;
		m_dwRipzeit += (dwStunde % 100) * 100;
		dwStunde /= 100;
		m_dwRipzeit += (dwStunde % 100) * 6000;
		dwStunde /= 100;
		m_dwRipzeit += (dwStunde % 100) * 360000;
    m_dwRipzeit /= 100;
	}
	m_dwRipzeit -= m_dwOffset;
	UpdateData (FALSE);
	OnKillfocusEditOffset ();
}

void CWinPVRDlg::SetfocusEditEndZeit ()
{
	// Test Test
	int i = 0;
}

void CWinPVRDlg::OnKillfocusEditOffset() 
{
	int nIndex;
	DWORD dw, dwTemp;
	UpdateData ();
	nIndex = m_wndContents.GetSelectionMark ();
	if (nIndex == -1) return;
	// Die anderen Werte werden nach verlassen des Edit-Feldes aus neuen Stand gebracht
	dw = m_pFD->iLengthHours * 3600 + m_pFD->iLengthMinutes * 60 + m_pFD->iLengthSeconds;
	if (m_dwRipzeit + m_dwOffset >= dw) m_dwRipzeit = dw - m_dwOffset - 1;
  dwTemp = (DWORD) m_dwOffset;
	m_sBeginnZeit.Format ("%d:%02d:%02d.%02d", dwTemp / 3600, (dwTemp % 3600) / 60, (dwTemp % 60), (int) (m_dwOffset * 100) %100);
  dwTemp = (DWORD) (m_dwRipzeit + m_dwOffset);
	m_sEndZeit.Format("%d:%02d:%02d.%02d", dwTemp / 3600, (dwTemp % 3600) / 60, (dwTemp % 60),
   (int) (((m_dwRipzeit + m_dwOffset) - (int)(m_dwRipzeit + m_dwOffset)) * 100)%100);
	UpdateData (FALSE);
}

void CWinPVRDlg::OnDblclkListContents(NMHDR* pNMHDR, LRESULT* pResult) 
{
  OnTitelPreview ();
  //UpdateData ();
  //int nIndex;
  //CString sBegin, sEnd;
  //double pos;
  //CDlgFileName dlg;
  //CSize size;
  //CRect rect;

  //nIndex = m_wndContents.GetSelectionMark ();
  //// Zeiten speichern
  //sBegin = m_sBeginnZeit;
  //sEnd = m_sEndZeit;

  //if (nIndex == -1) return;
  //// Daten des Files holen
  //m_pPVRFile = m_pDrive->File (nIndex);
  //m_pFD = m_pPVRFile->GetFileDescription ();
  //dlg.m_sFilename = m_pFD->cClipName;
  //if (dlg.DoModal () == IDOK)
  //{
  //  // Daten zurckschreiben und Liste wieder in Position bringen
  //  pos = (double) nIndex / (double) m_wndContents.GetItemCount ();
  //  m_wndContents.GetWindowRect (rect);
  //  size.cy = (LONG) ((rect.bottom - rect.top) * pos);
  //  strcpy (m_pFD->cClipName, dlg.m_sFilename);
  //  m_pPVRFile->WriteFileData (nIndex);
  //  OnButtonDir ();
  //  m_wndContents.SetSelectionMark (nIndex);
  //  m_wndContents.SetItemState(nIndex, LVIS_SELECTED, LVIS_SELECTED);
  //  m_wndContents.Scroll (size);
  //  OnClickListContents (pNMHDR, pResult);
  //}

  //*pResult = 0;
}


void CWinPVRDlg::OnTimer(UINT nIDEvent) 
{
	CWnd * pWnd;
	int i;
  CString s;
  __int64 i64Temp;
	// Hier werden die Events des asynchronen Rippertasks ausgewertet
	if (nIDEvent == 1)
	{
		if (m_InfoAudio.m_bProcess)
		{
			if (m_InfoAudio.m_bRunning)
			{
				// erste Update-Meldung Balken initialisieren
				if (m_InfoAudio.m_bFirstUpdate)
				{
					m_InfoAudio.m_bFirstUpdate = false;
					m_wndAudio.SetRange32 (m_InfoAudio.m_nStartPos, m_InfoAudio.m_nEndPos);
				}
				// Balken aktualisieren und gelesene MBs auch
				m_wndAudio.SetPos (m_InfoAudio.m_nPosition);
        s.Format ("Processing Audio % 3d %% ... %d Jobs to go", 
          (int) (((double) (m_InfoAudio.m_nPosition - m_InfoAudio.m_nStartPos)
          / (double) (m_InfoAudio.m_nEndPos - m_InfoAudio.m_nStartPos)) * 100.0), m_nNumberOfJobs);
        SetWindowText (s);
				m_sSizeAudio.Format ("%d MB", m_InfoAudio.m_nFileSize);
			}
		}
		if (m_InfoVideo.m_bProcess)
		{
			if (m_InfoVideo.m_bRunning)
			{
				// erste Update-Meldung Balken initialisieren
				if (m_InfoVideo.m_bFirstUpdate)
				{
					if (m_InfoAudio.m_bProcess)
						m_sAudioZeit.Format ("Time: %d s", m_InfoAudio.m_nRipTime);
					m_InfoVideo.m_bFirstUpdate = false;
					m_wndVideo.SetRange32 (m_InfoVideo.m_nStartPos, m_InfoVideo.m_nEndPos);
          i64Temp = m_InfoVideo.m_i64StartPos - m_InfoVideo.m_i64ClipStart;
          m_sStartPTS.Format ("Start PTS: %d:%02d:%02d", (int)(i64Temp / (90000 * 3600)), (int)((i64Temp / (90000 * 60)) % 60),(int)(i64Temp / 90000) % 60);
          i64Temp = m_InfoVideo.m_i64EndPos - m_InfoVideo.m_i64ClipStart;
          m_sEndPTS.Format ("End PTS: %d:%02d:%02d", (int)(i64Temp / (90000 *3600)), (int)(i64Temp / (90000 *60)) % 60,(int)(i64Temp / 90000) % 60);
					// m_sEndPTS.Format ("End PTS: %7I64X", m_InfoVideo.m_i64EndPos);
				}
				// Balken aktualisieren und gelesene MBs auch
				m_wndVideo.SetPos (m_InfoVideo.m_nPosition);
				m_sSizeVideo.Format ("%d MB", m_InfoVideo.m_nFileSize);
        s.Format ("Processing Video % 3d %% ... %d Jobs to go", 
          (int) (((double) (m_InfoVideo.m_nPosition - m_InfoVideo.m_nStartPos)
          / (double) (m_InfoVideo.m_nEndPos - m_InfoVideo.m_nStartPos)) * 100.0), m_nNumberOfJobs);
        SetWindowText (s);
			}
		}
		m_sVideo = m_InfoVideo.m_sInfo;	
		m_sAudio = m_InfoAudio.m_sInfo;
		UpdateData (false);
		UpdateWindow ();
	}
	// der Lesetask hat terminiert
	if (m_bReaderReady)
	{
		// Timer wieder abschalten
		KillTimer (1);
		// bentigte Zeit eintragen
		if (m_InfoVideo.m_bProcess)
			m_sVideoZeit.Format ("Time: %d s", m_InfoVideo.m_nRipTime);
		// Tasks laufen nicht mehr
		m_InfoAudio.m_bRunning = false;
		m_InfoVideo.m_bRunning = false;
		// PTS-Anzeigen lschen
		m_sStartPTS.Empty ();
		m_sEndPTS.Empty ();
		// GUI wieder eingabebereit machen
		m_wndRip.EnableWindow ();
		m_wndButtonDir.EnableWindow ();
		m_wndButtonOutputDir.EnableWindow ();
		m_wndContents.EnableWindow ();
		m_wndButtonSample.EnableWindow ();
 	  s = "WinPVR ";
    s += PVRVERSION;
#ifdef _DEBUG
    s += " Debug";
#else
    s += " Release";
#endif
    SetWindowText (s);

		for (i = IDC_FIRST_ITEM; i < IDC_LAST_ITEM; i++)
		{
			pWnd = GetDlgItem (i);
			if (pWnd != NULL)
				pWnd->EnableWindow (TRUE);
		}
		
		m_wndAudio.ShowWindow (SW_HIDE);
		m_wndVideo.ShowWindow (SW_HIDE);
		CloseLog ();
		UpdateData (false);
		// Schauen ob letzter Job erreicht
		if (m_bJobControl)
		{
			if (m_nNumberOfJobs)
			{
				OnRipStream ();
			}
			else
			{
				if (m_bPlaySound)
					PlaySound ("#5000", NULL, SND_ASYNC | SND_RESOURCE);
				m_bJobControl = FALSE;
			}

		}
		else
		{
			if (m_bPlaySound)
				PlaySound ("#5000", NULL, SND_ASYNC | SND_RESOURCE);
		}

	}
	CDialog::OnTimer(nIDEvent);
}

void CWinPVRDlg::OnRclickListContents(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CPoint point;
	CMenu menu;
	UpdateData (false);
	GetCursorPos (&point);

	int nItem = m_wndContents.GetSelectionMark ();
	if (nItem == -1) return;
	VERIFY(menu.LoadMenu(IDR_MENU_RIGHTCLICK));
	// Men anzeigen und Auswerten
	CMenu* pPopup = menu.GetSubMenu(0);
	ASSERT(pPopup != NULL);
	CWnd* pWndPopupOwner = this;

	while (pWndPopupOwner->GetStyle() & WS_CHILD)
		  pWndPopupOwner = pWndPopupOwner->GetParent();

	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
		  pWndPopupOwner);


	*pResult = 0;
}


void CWinPVRDlg::OnCancel() 
{
	CWnd * pWnd;
	int i;
	// je nach zustand Rip abbrechen oder nach Hause gehen
	if (m_bReaderReady)
	{
		SaveSettings ();
		CDialog::OnCancel();
	}
	else
	{
		for (i = IDC_FIRST_ITEM; i < IDC_LAST_ITEM; i++)
		{
			pWnd = GetDlgItem (i);
			if (pWnd != NULL)
				pWnd->EnableWindow (TRUE);
		}
		m_bCancel = true;
	}
}

void CWinPVRDlg::OnButtonScan() 
{
	DWORD dwTemp, dwLen, dwStep;
  double  dwOffset, dwRipzeit;
	CString sTempName, s, sName;
	UpdateData ();
	// ist noch experimentell
	int nItem = m_wndContents.GetSelectionMark ();
	if (nItem == -1) return;
	dwOffset = m_dwOffset;
	dwRipzeit = m_dwRipzeit;
	sTempName = m_wndContents.GetItemTrackTitle (nItem);
	sName = sTempName;
	if (sName.GetLength () > 30) sName = sName.Left (30);
	dwStep = (DWORD) (m_dwRipzeit / 10);

	if (dwStep < 600) dwStep = 600;
	m_dwRipzeit	= 120;
	dwLen = m_pFD->iLengthHours * 3600 + m_pFD->iLengthMinutes * 60 + m_pFD->iLengthSeconds;
	for (dwTemp = (DWORD) dwOffset; dwTemp < dwOffset + dwRipzeit ; dwTemp += dwStep)
	{
		s.Format ("%s_%02d:%02d:%02d",sName, dwTemp / 3600, (dwTemp - (dwTemp / 3600) * 3600) / 60, dwTemp % 60);
		strcpy (m_pFD->cClipName, s);
		m_dwOffset = dwTemp;
		m_bRipAudio = false;
		UpdateData (FALSE);
		OnButtonAddJob();
	}
	dwTemp = (DWORD) (dwRipzeit + dwOffset - 122);
	s.Format ("%s_%02d:%02d:%02d",sName, dwTemp / 3600, (dwTemp - (dwTemp / 3600) * 3600) / 60, dwTemp % 60);
	strcpy (m_pFD->cClipName, s);
	m_dwOffset = dwTemp;
	UpdateData (FALSE);
	OnButtonAddJob();
//	OnRipStream ();
	m_dwOffset = dwOffset;
	m_dwRipzeit = dwRipzeit;
	m_bRipAudio = true;
	strcpy (m_pFD->cClipName, sTempName);
	UpdateData (FALSE);
	OnKillfocusEditRipzeit ();
	WinExec ("E:\\Utils\\4NT\\4NT.EXE F:\\Images\\prev\\Preview.btm", SW_HIDE);
}


void CWinPVRDlg::OnButtonSample() 
{
 	UpdateData ();
	m_dwRipzeit	= 120;
	UpdateData (FALSE);
	OnRipStream ();
/*
	DWORD dwTemp, dwLen, dwOffset, dwRipzeit;
	CString sTempName, s, sName;
	// ist noch experimentell

	UpdateData ();
	dwOffset = m_dwOffset;
	dwRipzeit = m_dwRipzeit;
	sName = sTempName;
	if (sName.GetLength () > 30) sName = sName.Left (30);

	int nItem = m_wndContents.GetSelectionMark ();
	if (nItem == -1) return;
	sTempName = m_wndContents.GetItemTrackTitle (nItem);
	sName = sTempName;
	if (sName.GetLength () > 30) sName = sName.Left (30);
	dwTemp = m_dwRipzeit;
	dwLen = m_pFD->iLengthHours * 3600 + m_pFD->iLengthMinutes * 60 + m_pFD->iLengthSeconds;
	m_dwRipzeit	= 240;
	m_bRipAudio = false;
	s.Format ("%s_%02d:%02d:%02d",sName, m_dwOffset / 3600, (m_dwOffset - (m_dwOffset / 3600) * 3600) / 60, m_dwOffset % 60);
	strcpy (m_pFD->cClipName, s);
	UpdateData (FALSE);
	OnButtonAddJob();
	m_dwOffset += dwTemp;

	if (m_dwOffset + m_dwRipzeit > dwLen) m_dwRipzeit = dwLen - m_dwOffset;
	s.Format ("%s_%02d:%02d:%02d",sName, m_dwOffset / 3600, (m_dwOffset - (m_dwOffset / 3600) * 3600) / 60, m_dwOffset % 60);
	strcpy (m_pFD->cClipName, s);
	UpdateData (FALSE);
	OnButtonAddJob();
//	OnRipStream ();
	m_dwOffset = dwOffset;
	m_dwRipzeit = dwRipzeit;
	m_bRipAudio = true;
	strcpy (m_pFD->cClipName, sTempName);
	UpdateData (FALSE);
	OnKillfocusEditRipzeit ();
	WinExec ("E:\\Utils\\4NT\\4NT.EXE F:\\Images\\prev\\Preview.btm", SW_HIDE);
  */
}

void CWinPVRDlg::OnButtonAddJob() 
{
	UpdateData ();
	int nIndex, i, j (1);
	CString s;
	HANDLE hClipboard;

	nIndex = m_wndContents.GetSelectionMark ();

	if (nIndex == -1) return;
	// Job-Struct befllen
	m_pPVRFile = m_pDrive->File (nIndex);
	m_pFD = m_pPVRFile->GetFileDescription ();
	m_structJobs[m_nNumberOfJobs].dwOffset = m_dwOffset;
	m_structJobs[m_nNumberOfJobs].dwRipzeit = m_dwRipzeit;
	m_structJobs[m_nNumberOfJobs].nIndex = nIndex;
	m_structJobs[m_nNumberOfJobs].bRipAudioRaw = m_bRipAudioRaw;
	m_structJobs[m_nNumberOfJobs].sFilename = m_pFD->cClipName;
	m_structJobs[m_nNumberOfJobs].bMakeBackup = m_bMakeBackup;
	m_structJobs[m_nNumberOfJobs].bRipAudio = m_bRipAudio;
	m_structJobs[m_nNumberOfJobs].bRipVideo = m_bRipVideo;		
  m_structJobs[m_nNumberOfJobs].fSizeInGB =  ((double)(m_pFD->iAudioClusterCount + m_pFD->iVideoClusterCount) / 10.0) *
    (double) m_dwRipzeit / (double) (m_pFD->iLengthHours * 3600 + m_pFD->iLengthMinutes * 60 + m_pFD->iLengthSeconds);
	// Endzeit ins Clipboard (wenn man aufeinanderfolgende Clips hat)
	if (OpenClipboard ())
	{
		hClipboard = GlobalAlloc (GMEM_FIXED | GMEM_ZEROINIT, 255);
		if (hClipboard)
		{
			CopyMemory (hClipboard, m_sEndZeit, m_sEndZeit.GetLength ());
			SetClipboardData (CF_TEXT, hClipboard);
		}
		CloseClipboard ();
	}

	s.Empty ();
	// Wenn Job schon vorhanden - Index anhngen
	for (i = 0; i < m_nNumberOfJobs; i++)
	{
		if (m_structJobs[m_nNumberOfJobs].sFilename + s == m_structJobs[i].sFilename)
		{
			s.Format ("_%02d", j++);
		}
	}
	m_structJobs[m_nNumberOfJobs].sFilename += s;

	m_nNumberOfJobs += 1;
	m_bJobControl = TRUE;
	UpdateData (FALSE);
}

void CWinPVRDlg::OnButtonDelJobs()
{
	// Jobs lschen
	m_nNumberOfJobs = 0;
	m_bJobControl = FALSE;
	UpdateData (FALSE);
}


void CWinPVRDlg::OnMenuTitelaendern()
{
	UpdateData ();
	int nIndex;
	CDlgFileName dlg;
	nIndex = m_wndContents.GetSelectionMark ();
	if (nIndex == -1) return;
	m_pPVRFile = m_pDrive->File (nIndex);
	m_pFD = m_pPVRFile->GetFileDescription ();
	dlg.m_sFilename = m_pFD->cClipName;
	if (dlg.DoModal () == IDOK)
	{
    m_pPVRFile->SetFilename (dlg.m_sFilename);
		OnButtonDir ();
	}

}


void CWinPVRDlg::OpenLog(CString s)
{
	CString sTemp;
	CTime ctTime;
	ctTime = CTime::GetCurrentTime ();
	sTemp = ctTime.FormatGmt ("%d%m%Y_%H%M_");
	// falls einzelne Logs erwnscht
	if (m_bWriteLogFile)
	{
		s = sTemp + s + ".log";
	}
	else
	{
		s = "WinPVR.log";
	}
	pfsLog = new fstream(s,ios::out);
	pfsLog->precision(0);
	*pfsLog << "PVRRIPPER LOG " << VERSION << endl;

}

void CWinPVRDlg::CloseLog()
{
	if (pfsLog != NULL)
	{
		*pfsLog << "CPVRDrive::~CPVRDrive()" << endl;
		pfsLog->close ();
		delete pfsLog;	
		pfsLog = NULL;
	}
	
}

void CWinPVRDlg::OnButtonOutputDir() 
{
	CFileDialog dlg (true, NULL, "Select Directory", OFN_HIDEREADONLY);
	UpdateData ();
	dlg.m_ofn.lpstrInitialDir = m_sOutputDir.GetBuffer (255);
	m_sOutputDir.ReleaseBuffer ();
	if (dlg.DoModal () == IDOK)
	{
		m_sOutputDir = dlg.GetPathName ();
		// Dir Pfad filtern
		m_sOutputDir = m_sOutputDir.Left (m_sOutputDir.ReverseFind ('\\')+1);
	}
	// ins Verzeichnis wechseln
	_chdir (m_sOutputDir);
	UpdateData (false);
}

void CWinPVRDlg::LoadSettings()
{
	CString s, sKeyName, sKey;
	int i;
	// WinPVR.ini lesen
	GetModuleFileName (NULL, s.GetBuffer (255), 255);
	s.ReleaseBuffer ();
	s = s.Left (s.ReverseFind ('.')+1);
	s += "ini";
	GetPrivateProfileString ("WINPVR", "Output Directory", "D:\\Images\\", m_sOutputDir.GetBuffer (255), 255, s);
  m_sOutputDir.ReleaseBuffer ();
	m_bPlaySound  = GetPrivateProfileInt   ("WINPVR", "Play Sound", 1, s);
	m_bWriteLogFile = GetPrivateProfileInt ("WINPVR", "Log File", 1, s);
	g_bFirmware = (GetPrivateProfileInt  ("WINPVR", "Firmware190", 0, s) != 0);
  m_bPatchSeqHeader = (GetPrivateProfileInt  ("WINPVR", "Patch first sequence header", 0, s) != 0);

	for (i = 0; i < 200; i++)
	{
		sKeyName.Format ("RawAudio_%03d", i);
		GetPrivateProfileString ("WINPVR", sKeyName, "", sKey.GetBuffer (255), 255, s);
		sKey.ReleaseBuffer ();
		if (!sKey.IsEmpty ())
		{
			m_saRawAudio.Add (sKey);
		}
	}
	GetPrivateProfileString ("WINPVR", "Prefix Video", "m2v", m_sPrefixVideo.GetBuffer (255), 255, s);
  m_sPrefixVideo.ReleaseBuffer ();
	GetPrivateProfileString ("WINPVR", "Prefix Audio", "mp2", m_sPrefixAudio.GetBuffer (255), 255, s);
  m_sPrefixAudio.ReleaseBuffer ();
	GetPrivateProfileString ("WINPVR", "Prefix Raw Video", "pva", m_sPrefixRawVideo.GetBuffer (255), 255, s);
  m_sPrefixRawVideo.ReleaseBuffer ();
	GetPrivateProfileString ("WINPVR", "Prefix Raw Audio", "mpp", m_sPrefixRawAudio.GetBuffer (255), 255, s);
  m_sPrefixRawAudio.ReleaseBuffer ();
  m_InfoAudio.m_sPrefix    = m_sPrefixAudio;
  m_InfoAudio.m_sPrefixRaw = m_sPrefixRawAudio;
  m_InfoVideo.m_sPrefix    = m_sPrefixVideo;
  m_InfoVideo.m_sPrefixRaw = m_sPrefixRawVideo;
 	UpdateData (FALSE);
}

void CWinPVRDlg::SaveSettings()
{
	UpdateData (false);
	CString s, sBool, sKeyName;
	int i;
	// WinPVR.ini schreiben
	GetModuleFileName (NULL, s.GetBuffer (255), 255);
	s.ReleaseBuffer ();
	s = s.Left (s.ReverseFind ('.')+1);
	s += "ini";
	WritePrivateProfileString ("WINPVR", "Output Directory", m_sOutputDir, s);
	sBool.Format ("%d", m_bPlaySound);
	WritePrivateProfileString ("WINPVR", "Play Sound", sBool, s);
	sBool.Format ("%d", m_bWriteLogFile);
	WritePrivateProfileString ("WINPVR", "Log File", sBool, s);
	sBool.Format ("%d", g_bFirmware);
	WritePrivateProfileString ("WINPVR", "Firmware190", sBool, s);
	sBool.Format ("%d", m_bPatchSeqHeader);
	WritePrivateProfileString ("WINPVR", "Patch first sequence header", sBool, s);

	for (i = 0; i < m_saRawAudio.GetSize (); i++)
	{
		sKeyName.Format ("RawAudio_%03d", i);
		WritePrivateProfileString ("WINPVR", sKeyName, m_saRawAudio.GetAt (i), s);
	}
	WritePrivateProfileString ("WINPVR", "Prefix Video", m_sPrefixVideo, s);
	WritePrivateProfileString ("WINPVR", "Prefix Audio", m_sPrefixAudio, s);
	WritePrivateProfileString ("WINPVR", "Prefix Raw Video", m_sPrefixRawVideo, s);
	WritePrivateProfileString ("WINPVR", "Prefix Raw Audio", m_sPrefixRawAudio, s);
  m_InfoAudio.m_sPrefix    = m_sPrefixAudio;
  m_InfoAudio.m_sPrefixRaw = m_sPrefixRawAudio;
  m_InfoVideo.m_sPrefix    = m_sPrefixVideo;
  m_InfoVideo.m_sPrefixRaw = m_sPrefixRawVideo;
}


void CWinPVRDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Code fr die Behandlungsroutine fr Nachrichten hier einfgen und/oder Standard aufrufen
	
	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CWinPVRDlg::OnButtonRestore ()
{
  CPreviewDialog dlg;
  dlg.Init (NULL);
  dlg.DoModal ();

//	UpdateData ();
//	CString s;
// hier sollte nichts angefasst werden - man kann damit die Aufnahmen auf der Platte schrotten !!!


//	nIndex = m_wndContents.GetSelectionMark ();

//	if (nIndex == -1) return;
//	m_bRestoreBackup = TRUE;
/*
	m_pPVRFile = m_pDrive->File (nIndex);
	sFD = m_pPVRFile->GetFileDescription ();
	m_dwOffset = sFD->ssiSkipIndex[0].iStart * 25;
	m_dwRipzeit = sFD->ssiSkipIndex[0].iStop * 26 - m_dwOffset;
	UpdateData (FALSE);
	sFileDescription * psfd;
	CFile fIn;
	sFatPointer * sfp;
	__int16 nNextCluster, nThisCluster;
	int i;
	CPVRFile * pPVRFile;
	m_bRestoreBackup = TRUE;
	CString s;


	sfp = NULL;
	CFileDialog dlg (true, NULL, "*.sFileDescription", OFN_HIDEREADONLY);
	if (dlg.DoModal () == IDOK)
	{
		s = dlg.GetPathName ();
		if (! fIn.Open (s, CFile::modeRead))
			return;
		s = s.Left (s.ReverseFind ('\\')+1);
		_chdir (s);
		psfd = new sFileDescription;
		fIn.Read (psfd, sizeof (sFileDescription));
		for (i = 1; i <= psfd->iAudioClusterCount; i++)
		{
			sfp = g_pfatFAT->GetFreeFatPointer (nThisCluster, nNextCluster);
			sfp->uiClusterType = 0xFE;
			sfp->uiNextFatPointer = nNextCluster;
			sfp->uiClusterSequenceNumber = i;
			if (i == 1)
			{
				psfd->iAudioFatEntry = nThisCluster;
				sfp->uiClusterSequenceNumber = 0xFF;
			}
			m_pDrive->GetNewCluster ();
		}
		sfp->uiNextFatPointer = INVALID_POINTER;
		for (i = 1; i <= psfd->iVideoClusterCount; i++)
		{
			sfp = g_pfatFAT->GetFreeFatPointer (nThisCluster, nNextCluster);
			sfp->uiClusterType = 0xFD;
			sfp->uiNextFatPointer = nNextCluster;
			sfp->uiClusterSequenceNumber = i;
			if (i == 1)
			{
				psfd->iVideoFatEntry = nThisCluster;
				sfp->uiClusterSequenceNumber = 0xFF;
			}
			m_pDrive->GetNewCluster ();
		}
		sfp->uiNextFatPointer = INVALID_POINTER;
		pPVRFile = new CPVRFile (m_pDrive->GetDriveName (), psfd);
		m_pDrive->AddFile (pPVRFile);
		OnButtonDir ();
		m_wndContents.SetSelectionMark (m_pDrive->FilesCount () - 1);
		m_wndContents.SetItemState(m_pDrive->FilesCount () - 1, LVIS_SELECTED, LVIS_SELECTED);
		RipStream ();
		m_pDrive->WriteDriveData ();
		m_pDrive->WriteFileData (m_pDrive->FilesCount () - 1);
		g_pfatFAT->WriteFatData ();

	}
*/
}

void CWinPVRDlg::OnAddtorawaudiolist() 
{
	UpdateData ();
	int nIndex, i;
	CString s;
	// hier werden die Eintrge fr die Liste der Sender gemacht, bei denen die Audiodaten roh gerippt werden mssen
	nIndex = m_wndContents.GetSelectionMark ();

	if (nIndex == -1) return;
	s = m_wndContents.GetItemChannel (nIndex);
	for (i = 0; i < m_saRawAudio.GetSize (); i++)
	{
		if (s == m_saRawAudio.GetAt (i)) 
		{
			break;
		}

	}
	if (i == m_saRawAudio.GetSize ()) 
	{
		m_bRipAudioRaw = TRUE;
		m_saRawAudio.Add (s); // noch nicht vorhanden
		UpdateData (FALSE);
	}
}


void CWinPVRDlg::OnButtonSaveJobs() 
{
	CStdioFile fOut;
	CString sOut;
	int i, nBegin, nEnd, nTemp, nEndMS, nBeginMS;

	// Abspeichern der Jobs in CSV-Format (Excel)
	if (m_nNumberOfJobs == 0) return;
	if (!fOut.Open ("WINPVR_Joblist.csv", CFile::modeCreate | CFile::modeWrite | CFile::typeText))
	{
		MessageBox("File could not be opened !", "WINPVR_Joblist.csv", MB_ICONSTOP);
		return;
	}

	fOut.WriteString ("Index;Name;Begin;End;Rip Audio;Rip Video;Rip Audio Raw;Rip Video Raw;Checksum\n");
	for (i = 0; i < m_nNumberOfJobs; i++)
	{
		// Zeiten formatieren
		nTemp = (DWORD)  m_structJobs[i].dwOffset;
		nBegin = (nTemp / 3600 * 10000) + ((nTemp - ((nTemp / 3600) * 3600)) / 60) * 100 + (nTemp % 60);
    nBeginMS = (int) (m_structJobs[i].dwOffset * 100.0) % 100;
		nTemp = (DWORD) (m_structJobs[i].dwOffset + m_structJobs[i].dwRipzeit);
		nEnd = (nTemp / 3600 * 10000) + ((nTemp - ((nTemp / 3600) * 3600)) / 60) * 100 + (nTemp % 60);
    nEndMS = (int) ((m_structJobs[i].dwOffset + m_structJobs[i].dwRipzeit) * 100.0) % 100;
		sOut.Format ("%d;%s;%d.%02d;%d.%02d;%d;%d;%d;%d;%08X\n", m_structJobs[i].nIndex+1, m_structJobs[i].sFilename, 
			nBegin, nBeginMS, nEnd, nEndMS, m_structJobs[i].bRipAudio, m_structJobs[i].bRipVideo, 
			m_structJobs[i].bRipAudioRaw, m_structJobs[i].bRipVideoRaw, m_dwaCheckSums.GetAt (m_structJobs[i].nIndex));
		fOut.WriteString (sOut);
	}
	fOut.Close ();
}

static char BASED_CODE szFilter[] = "Joblist Files (*.csv)|*.csv|All Files (*.*)|*.*||";


void CWinPVRDlg::OnButtonLoadJobs() 
{
	CFileDialog dlg (true, NULL, "*.csv", OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, szFilter);
	CString sInput, s,s1;
	CStdioFile fIn;
	TJobEntry Job;
  bool bExtended (false);
	int nTime, i, nIndexNumber (0);
  double dTime;
	UpdateData ();
	// ist noch buggy knnte Feinschliff vertragen (Abfragen ob Feld gesetzt ist - Fehler abfangen)
	dlg.m_ofn.lpstrInitialDir = m_sOutputDir;
	m_sOutputDir.ReleaseBuffer ();
	if (dlg.DoModal () == IDOK)
	{
		sInput = dlg.GetPathName ();
		if (!fIn.Open (sInput, CFile::modeRead | CFile::shareDenyNone | CFile::typeText))
		{
			MessageBox("File could not be opened !", sInput, MB_ICONSTOP);
			return;
		}
		while (fIn.ReadString (sInput))
		{
			if (sInput.Find (";") == -1) continue;
			sInput += "\n";
			s = sInput.Left (sInput.Find (";"));
			// Jobzeile gefunden
			if (isdigit (s[0]))
			{
				m_structJobs[m_nNumberOfJobs].nIndex = atoi (s) - 1;
				// String Name
				sInput = sInput.Mid (sInput.Find (";") + 1);
				m_structJobs[m_nNumberOfJobs].sFilename = sInput.Left (sInput.Find (";"));
				// Anfangszeit
				sInput = sInput.Mid (sInput.Find (";") + 1);
				if (sInput[0] == 'x')  // Index statt zeit
				{
					sFileDescription * sFD;
					double fLength, fMin, f2Min;
					DWORD dwAdd (10);
					sscanf (sInput, "x%d;", &nIndexNumber);
					m_pPVRFile = m_pDrive->File (m_structJobs[m_nNumberOfJobs].nIndex);
					sFD = m_pPVRFile->GetFileDescription ();
					// Lngenwerte prfen
					fLength = sFD->iLengthHours * 3600 + sFD->iLengthMinutes * 60 + sFD->iLengthSeconds;
					fMin = fLength / 1000.0 * sFD->ssiSkipIndex[0].iStart;
					f2Min = fLength / 1000.0 * sFD->ssiSkipIndex[0].iStop;

					if (dwAdd < (fLength / 1000.0 * sFD->ssiSkipIndex[nIndexNumber].iStart))
						m_structJobs[m_nNumberOfJobs].dwOffset = (DWORD) (fLength / 1000.0 * sFD->ssiSkipIndex[nIndexNumber].iStart) - dwAdd;
					else
						m_structJobs[m_nNumberOfJobs].dwOffset = 0;
					if (m_structJobs[m_nNumberOfJobs].dwOffset  < 0) m_structJobs[m_nNumberOfJobs].dwOffset = 0;
					m_structJobs[m_nNumberOfJobs].dwRipzeit = (DWORD) (fLength / 1000.0 * sFD->ssiSkipIndex[nIndexNumber].iStop);
					m_structJobs[m_nNumberOfJobs].dwRipzeit -= (m_structJobs[m_nNumberOfJobs].dwOffset - dwAdd * 2);
					sInput = sInput.Mid (sInput.Find (";") + 1);
				}
				else
				{
					dTime = atof (sInput.Left (sInput.Find (";")));
          nTime = (DWORD) dTime;
					m_structJobs[m_nNumberOfJobs].dwOffset = (nTime / 10000) * 3600 + ((nTime % 10000) / 100) * 60 + (nTime % 100);
          dTime = (DWORD) (dTime * 100) % 100;
          dTime /= 100;
          m_structJobs[m_nNumberOfJobs].dwOffset += dTime;
					sInput = sInput.Mid (sInput.Find (";") + 1);
					dTime = atof (sInput.Left (sInput.FindOneOf (";\n")));
          nTime = (DWORD) dTime;
					m_structJobs[m_nNumberOfJobs].dwRipzeit = (nTime / 10000) * 3600 + ((nTime % 10000) / 100) * 60 + (nTime % 100);
          dTime = (DWORD) (dTime * 100) % 100;
          dTime /= 100;
          m_structJobs[m_nNumberOfJobs].dwRipzeit += dTime;
					m_structJobs[m_nNumberOfJobs].dwRipzeit -= m_structJobs[m_nNumberOfJobs].dwOffset;
				}
				// more to come (2. Format)
				if (sInput.Find (";") != -1)
				{
          bExtended = true;
          if (sInput.Find (";") != -1)
          {
					  sInput = sInput.Mid (sInput.Find (";") + 1);
					  m_structJobs[m_nNumberOfJobs].bRipAudio = atoi (sInput.Left (sInput.FindOneOf (";\n")));
          }
          else
          {
            m_structJobs[m_nNumberOfJobs].bRipAudio = TRUE;
          }
          if (sInput.Find (";") != -1)
          {
					  sInput = sInput.Mid (sInput.Find (";") + 1);
					  m_structJobs[m_nNumberOfJobs].bRipVideo = atoi (sInput.Left (sInput.FindOneOf (";\n")));
          }
          else
          {
            m_structJobs[m_nNumberOfJobs].bRipVideo = TRUE;
          }
          if (sInput.Find (";") != -1)
          {
					  sInput = sInput.Mid (sInput.Find (";") + 1);
					  m_structJobs[m_nNumberOfJobs].bRipAudioRaw = atoi (sInput.Left (sInput.FindOneOf (";\n")));
          }
          else
          {
            m_structJobs[m_nNumberOfJobs].bRipAudioRaw = FALSE;
          }
          if (sInput.Find (";") != -1)
          {
					  sInput = sInput.Mid (sInput.Find (";") + 1);
					  m_structJobs[m_nNumberOfJobs].bRipVideoRaw = atoi (sInput.Left (sInput.FindOneOf (";\n")));
          }
          else
          {
            m_structJobs[m_nNumberOfJobs].bRipVideoRaw = FALSE;
          }
          if (sInput.Find (";") != -1)
          {
            DWORD dwChecksum;
					  sInput = sInput.Mid (sInput.Find (";") + 1);
            sInput = sInput.Left (sInput.FindOneOf (";\n"));
            sscanf (sInput, "%08X", &dwChecksum);
            if (dwChecksum != CheckSum (m_structJobs[m_nNumberOfJobs].nIndex))
            {
              int i;
              for (i = 0; i < m_dwaCheckSums.GetSize (); i++)
              {
                if (dwChecksum == m_dwaCheckSums[i])
                {
                  m_structJobs[m_nNumberOfJobs].nIndex = i;
                  break;
                }
              }
              if (i == m_dwaCheckSums.GetCount ()) MessageBox (m_structJobs[m_nNumberOfJobs].sFilename, "Not Found - Correct CSV", MB_ICONHAND);
            }
          }

				}
				else
				{
					m_structJobs[m_nNumberOfJobs].bRipAudio = TRUE;
					m_structJobs[m_nNumberOfJobs].bRipVideo = TRUE;
					m_structJobs[m_nNumberOfJobs].bSplitRecording = FALSE;
				}
				m_structJobs[m_nNumberOfJobs].bMakeBackup = FALSE;
        m_structJobs[m_nNumberOfJobs].fSizeInGB =  ((double)(m_pFD->iAudioClusterCount + m_pFD->iVideoClusterCount) / 10.0) *
        (double) m_structJobs[m_nNumberOfJobs].dwRipzeit / (double) (m_pFD->iLengthHours * 3600 + m_pFD->iLengthMinutes * 60 + m_pFD->iLengthSeconds);

				// Audio Raw ????
				s = m_wndContents.GetItemChannel (m_structJobs[m_nNumberOfJobs].nIndex);
				for (i = 0; i < m_saRawAudio.GetSize () && !bExtended; i++)
				{
					if (m_saRawAudio.GetAt (i) == s.Left (m_saRawAudio.GetAt (i).GetLength ()))
					{
						m_structJobs[m_nNumberOfJobs].bRipAudioRaw = TRUE;
						break;
					}
				}
				if (i == m_saRawAudio.GetSize ()) m_structJobs[m_nNumberOfJobs].bRipAudioRaw = FALSE;
				m_nNumberOfJobs++;
				m_bJobControl = TRUE;

			}
		}
		fIn.Close ();
	}
	UpdateData (false);
	_chdir (m_sOutputDir);
}

void CWinPVRDlg::OnBnClickedCheckFirmware190()
{
 	delete g_pfatFAT;
	delete m_pDrive;
  g_pfatFAT = NULL;
  m_pDrive = NULL;
  g_bFirmware = !g_bFirmware;
  OnButtonDir ();
}


void CWinPVRDlg::OnTitelPreview()
{
  CPreviewDialog dlg;
	UpdateData ();
	int nIndex;
	CString s;
  nIndex = m_wndContents.GetSelectionMark ();
	if (nIndex == -1) return;
 	m_pPVRFile = m_pDrive->File (nIndex);
	m_pPVRFile->m_pInfoAudio = &m_InfoAudio;
	m_pPVRFile->m_pInfoVideo = &m_InfoVideo;
	OpenLog ("PRV.LOG");
	
	m_InfoAudio.m_bProcess = false;
	m_InfoAudio.m_bRipRaw = false;
	m_InfoVideo.m_bMakeBackup = false;
	m_InfoVideo.m_bRipRaw = false;
	m_InfoVideo.m_bProcess = true;
	m_InfoAudio.m_bMakeBackup = false;
  m_InfoVideo.m_bPatchSeqHeader = false;
  dlg.Init (m_pPVRFile);
  dlg.m_bRipAudioRaw = m_bRipAudioRaw;
  dlg.m_bRipStreamRaw = m_bRipVideoRaw;

  if (dlg.DoModal () == IDOK)
  {
    for (int i = 0; i < dlg.m_nNumberOfJobs; i++)
    {
      m_structJobs[m_nNumberOfJobs].bMakeBackup = dlg.m_structJobs[i].bMakeBackup;
      m_structJobs[m_nNumberOfJobs].bRestoreBackup = dlg.m_structJobs[i].bRestoreBackup;
      m_structJobs[m_nNumberOfJobs].bRipAudio = dlg.m_structJobs[i].bRipAudio;
      m_structJobs[m_nNumberOfJobs].bRipAudioRaw = dlg.m_structJobs[i].bRipAudioRaw;
      m_structJobs[m_nNumberOfJobs].bRipVideo = dlg.m_structJobs[i].bRipVideo;
      m_structJobs[m_nNumberOfJobs].bRipVideoRaw = dlg.m_structJobs[i].bRipVideoRaw;
      m_structJobs[m_nNumberOfJobs].bSplitRecording = dlg.m_structJobs[i].bSplitRecording;
      m_structJobs[m_nNumberOfJobs].dwOffset = dlg.m_structJobs[i].dwOffset;
      m_structJobs[m_nNumberOfJobs].dwRipzeit = dlg.m_structJobs[i].dwRipzeit;
      m_structJobs[m_nNumberOfJobs].nIndex = dlg.m_structJobs[i].nIndex;
      m_structJobs[m_nNumberOfJobs].sFilename = dlg.m_structJobs[i].sFilename;
      m_structJobs[m_nNumberOfJobs].fSizeInGB = dlg.m_structJobs[i].fSizeInGB;
      m_bJobControl = TRUE;
      m_nNumberOfJobs++;
    }
    if (dlg.m_nNumberOfJobs)
    {
      m_pPVRFile->SetFilename (m_structJobs[m_nNumberOfJobs-1].sFilename);
    }
  	UpdateData (FALSE);
		OnButtonDir ();
  }
  CloseLog ();
}


void CWinPVRDlg::OnBnClickedButtonPatchFile()
{
  CFileDialog dlg (TRUE);
  CString sFilename;
  CFile fMPG;
  BYTE * buf;
  buf = new BYTE[0x1000000];
  int i;
  if (dlg.DoModal () == IDOK)
  {
    sFilename = dlg.GetPathName ();
    if (fMPG.Open (sFilename, CFile::modeReadWrite))
    {
      fMPG.Read (buf, sizeof (buf));
      for (i = 0; i < sizeof (buf); i++)
      {
        if (buf[i] == 0 && buf[i+1] == 0 && buf[i+2] == 1 && buf[i+3] == 0xb3)
        {
          i = i;
          if (buf[i+4] != 0x2d)
          {
            buf[i+4] = 0x2d;
            buf[i+5] = 0x02;
            buf[i+6] = 0x40;
            fMPG.SeekToBegin ();
            fMPG.Write (buf, sizeof (buf));
          }

          break;
        }
      }
      fMPG.Close ();
    }
  }
  delete buf;
}

// computes Checksum over essential parts of a Clip
DWORD CWinPVRDlg::CheckSum(int nFileNumber)
{
  WORD nAddCheck (0), nXORCheck (0);
  DWORD dwCheckSum (0);
  if (nFileNumber < m_pDrive->FilesCount ())
  {
	  m_pPVRFile = m_pDrive->File (nFileNumber);
	  m_pFD = m_pPVRFile->GetFileDescription ();
    nAddCheck += m_pFD->iAudioClusterCount;
    nAddCheck += m_pFD->iVideoClusterCount;
    nAddCheck += m_pFD->iAudioFatEntry;
    nAddCheck += m_pFD->iVideoFatEntry;
    nAddCheck += m_pFD->iLengthHours;
    nAddCheck += m_pFD->iLengthMinutes;
    nAddCheck += m_pFD->iLengthSeconds;
    nAddCheck += m_pFD->iRecordDay;
    nAddCheck += m_pFD->iRecordHour;
    nAddCheck += m_pFD->iRecordMinute;
    nAddCheck += m_pFD->iRecordMonth;
    nAddCheck += m_pFD->iRecordSecond;
    nXORCheck ^= m_pFD->iAudioClusterCount;
    nXORCheck ^= m_pFD->iVideoClusterCount;
    nXORCheck ^= m_pFD->iAudioFatEntry;
    nXORCheck ^= m_pFD->iVideoFatEntry;
    nXORCheck ^= m_pFD->iLengthHours;
    nXORCheck ^= m_pFD->iLengthMinutes;
    nXORCheck ^= m_pFD->iLengthSeconds;
    nXORCheck ^= m_pFD->iRecordDay;
    nXORCheck ^= m_pFD->iRecordHour;
    nXORCheck ^= m_pFD->iRecordMinute;
    nXORCheck ^= m_pFD->iRecordMonth;
    nXORCheck ^= m_pFD->iRecordSecond;
    dwCheckSum = nAddCheck;
    dwCheckSum <<= 16;
    dwCheckSum |= nXORCheck;
  }
  return dwCheckSum;
}

void CWinPVRDlg::OnBnClickedButtonOptions()
{
  CDlgOptions dlg;
  dlg.m_sPrefixAudio    = m_sPrefixAudio;
  dlg.m_sPrefixRawAudio = m_sPrefixRawAudio;
  dlg.m_sPrefixRawVideo = m_sPrefixRawVideo;
  dlg.m_sPrefixVideo    = m_sPrefixVideo;
  if (dlg.DoModal () == IDOK)
  {
    m_sPrefixAudio    = dlg.m_sPrefixAudio;
    m_sPrefixRawAudio = dlg.m_sPrefixRawAudio;
    m_sPrefixRawVideo = dlg.m_sPrefixRawVideo;
    m_sPrefixVideo    = dlg.m_sPrefixVideo;
  }
  SaveSettings ();
}
