// WinPVRDlg.h : Header-Datei
//

#if !defined(AFX_WINPVRDLG_H__F2C7DB78_DA18_43B0_A40E_C1A34A3885F1__INCLUDED_)
#define AFX_WINPVRDLG_H__F2C7DB78_DA18_43B0_A40E_C1A34A3885F1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CWinPVRDlg Dialogfeld
#include "ctrlext.h"
#include "pvrfile.h"
#include "pvrdrive.h"
#include "ReaderThread.h"	// Hinzugefgt von der Klassenansicht
#include "InfoBlock.h"


class CWinPVRDlg : public CDialog
{
// Konstruktion
public:
	CReaderThread * m_pcrThread;
	CWinPVRDlg(CWnd* pParent = NULL);	// Standard-Konstruktor

// Dialogfelddaten
	//{{AFX_DATA(CWinPVRDlg)
	enum { IDD = IDD_WINPVR_DIALOG };
	CButton	m_wndButtonSample;
	CButton	m_wndButtonOutputDir;
	CButton	m_wndButtonDir;
	CButton	m_wndRip;
	CProgressCtrl	m_wndAudio;
	CProgressCtrl	m_wndVideo;
	CListCtrlEx m_wndContents;
	CComboBox	m_cbDrive;
	BOOL	m_bRipAudio;
	BOOL	m_bRipVideo;
	CString	m_sDrive;
	CString	m_sAudio;
	CString	m_sVideo;
	double	m_dwRipzeit;
	double	m_dwOffset;
	CString	m_sEndPTS;
	CString	m_sStartPTS;
	CString	m_sVideoZeit;
	CString	m_sAudioZeit;
	CString	m_sSizeAudio;
	CString	m_sSizeVideo;
	CString	m_sOutputDir;
	BOOL	m_bPlaySound;
	BOOL	m_bWriteLogFile;
	CString	m_sBeginnZeit;
	CString	m_sEndZeit;
	BOOL	m_bRipAudioRaw;
  BOOL  m_bRipVideoRaw;
	CString	m_sJobNumber;
	BOOL	m_bMakeBackup;
	CString	m_sDriveCapacity;
	CString	m_sDriveType;
	CString	m_sFreespace;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CWinPVRDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CWinPVRDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonDir();
	afx_msg void OnClickListContents(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnRipStream();
	afx_msg void OnKillfocusEditRipzeit();
	afx_msg void OnKillfocusEditOffset();
	afx_msg void OnKillfocusEditBeginnZeit();
	afx_msg void OnKillfocusEditEndeZeit();
	afx_msg void SetfocusEditEndZeit ();
	afx_msg void OnTimer(UINT nIDEvent);
	virtual void OnCancel();
	afx_msg void OnButtonSample();
	afx_msg void OnButtonRestore();
	afx_msg void OnButtonAddJob();
	afx_msg void OnButtonDelJobs();
	afx_msg void OnButtonOutputDir();
	afx_msg void OnDblclkListContents(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnMenuTitelaendern();
	afx_msg void OnAddtorawaudiolist();
	afx_msg void OnButtonScan();
	afx_msg void OnButtonSaveJobs();
	afx_msg void OnButtonLoadJobs();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	HICON m_hIcon;
	CStringArray m_saRawAudio;
	BOOL m_bRestoreBackup;
	BOOL m_bJobControl;
	void RipStream ();
	void SaveSettings ();
	void LoadSettings ();
	CBitmap m_wndFolderBitmap;
	void CloseLog ();
	void OpenLog (CString s);
	bool m_bCancel;
	bool m_bReaderReady;
	sFileDescription * m_pFD;
	CPVRDrive * m_pDrive;
	CPVRFile * m_pPVRFile;
	CInfoBlock m_InfoAudio, m_InfoVideo;
	TJobEntry m_structJobs[100];
	int m_nNumberOfJobs;
	DWORD	m_dwRipzeitBck;
	DWORD	m_dwOffsetBck;
  CString m_sPrefixVideo;
  CString m_sPrefixAudio;
  CString m_sPrefixRawVideo;
  CString m_sPrefixRawAudio;
public:
	afx_msg void OnRclickListContents(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg BOOL OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult );
  afx_msg void OnBnClickedCheckFirmware190();
private:
  CString m_sJobSize;
public:
  afx_msg void OnTitelPreview();
  BOOL m_bPatchSeqHeader;
  afx_msg void OnBnClickedButtonPatchFile();
  // // computes Checksum over essential parts of a Clip
  DWORD CheckSum(int nFileNumber);
private:
  // // Checksums for Files
  CDWordArray m_dwaCheckSums;
public:
  afx_msg void OnBnClickedButtonOptions();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_WINPVRDLG_H__F2C7DB78_DA18_43B0_A40E_C1A34A3885F1__INCLUDED_)
