// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1995 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#include "stdafx.h"
#include "ctrlext.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define new DEBUG_NEW

/////////////////////////////////////////////////////////////////////////////
// Inline function declarations

#define _AFXCTL_INLINE inline

/////////////////////////////////////////////////////////////////////////////
// CListCtrlEx

BOOL CListCtrlEx::AddColumn(LPCTSTR strItem,int nItem,int nSubItem,int nMask,int nFmt)
{
	LV_COLUMN lvc;
	lvc.mask = nMask;
	lvc.fmt = nFmt;
	lvc.pszText = (LPTSTR) strItem;
	lvc.cx = GetStringWidth(lvc.pszText) + 15;
	if(nMask & LVCF_SUBITEM){
		if(nSubItem != -1)
			lvc.iSubItem = nSubItem;
		else
			lvc.iSubItem = nItem;
	}
	return InsertColumn(nItem,&lvc);
}

BOOL CListCtrlEx::AddItem(int nItem,int nSubItem,LPCTSTR strItem,int nImageIndex)
{
	LV_ITEM lvItem;
	lvItem.mask = LVIF_TEXT;
	lvItem.iItem = nItem;
	lvItem.iSubItem = nSubItem;
	lvItem.pszText = (LPTSTR) strItem;
	if(nImageIndex != -1){
		lvItem.mask |= LVIF_IMAGE;
		lvItem.iImage |= LVIF_IMAGE;
	}
	if(nSubItem == 0)
		return InsertItem(&lvItem);
	return SetItem(&lvItem);
}

/////////////////////////////////////////////////////////////////////////////
CString CListCtrlEx::GetItemChannel(int i)
{
	LV_ITEM lvItem;
	lvItem.mask = LVIF_TEXT;
	lvItem.iItem = i;
	lvItem.cchTextMax = 255;
	lvItem.iSubItem = 1;
	lvItem.pszText = m_sTime.GetBuffer(255);
	GetItem(&lvItem);
	m_sTime.ReleaseBuffer();
	return (m_sTime);
}

CString CListCtrlEx::GetItemTrackTitle(int i)
{
	LV_ITEM lvItem;
	lvItem.mask = LVIF_TEXT;
	lvItem.iItem = i;
	lvItem.cchTextMax = 255;
	lvItem.iSubItem = 2;
	lvItem.pszText = m_sTrackName.GetBuffer(255);
	GetItem(&lvItem);
	m_sTrackName.ReleaseBuffer();
	return (m_sTrackName);
}


CString CListCtrlEx::GetItemDate (int i)
{
	LV_ITEM lvItem;
	lvItem.mask = LVIF_TEXT;
	lvItem.iItem = i;
	lvItem.cchTextMax = 255;
	lvItem.iSubItem = 4;
	lvItem.pszText = m_sAlbum.GetBuffer(255);
	GetItem(&lvItem);
	m_sAlbum.ReleaseBuffer();
	return (m_sAlbum);
}

CString CListCtrlEx::GetItemLength(int i)
{
	LV_ITEM lvItem;
	lvItem.mask = LVIF_TEXT;
	lvItem.iItem = i;
	lvItem.cchTextMax = 255;
	lvItem.iSubItem = 3;
	lvItem.pszText = m_sInterpret.GetBuffer(255);
	GetItem(&lvItem);
	m_sInterpret.ReleaseBuffer();
	return (m_sInterpret);
}

void CListCtrlEx::SwapItems(int i, int j)
{
}

BOOL CListCtrlEx::SetItemTrackTitle(int i, CString s)
{
	LV_ITEM lvItem;
	BOOL bRet;
	lvItem.mask = LVIF_TEXT;
	lvItem.iItem = i;
	lvItem.cchTextMax = 255;
	lvItem.iSubItem = 2;
	lvItem.pszText = s.GetBuffer(255);
	bRet = SetItem(&lvItem);
	s.ReleaseBuffer();
	return (bRet);
}
