#include "stdafx.h"



#include "fat.h"
#include <iomanip>
using namespace std;

CFAT::CFAT(const string &Drivename, bool &Okay)
{
	DWORD			dwBytesRead;
  CFile fDeb;

	m_sfpFatPointer=NULL;
	m_hFile=INVALID_HANDLE_VALUE;
	Okay=false;
  if (Drivename == "REC")
  {
    m_sfpFatPointer=new sFatPointer[MAX_FATPOINTERS];
   	if (fDeb.Open ("driveheader.rec", CFile::modeRead | CFile::typeBinary))
  	{
      fDeb.Seek (BYTES_PER_SECTOR, CFile::begin);
	  	fDeb.Read (m_sfpFatPointer, sizeof(FAT_BUFFER_SIZE));
		  fDeb.Close ();
	  }
    Okay=true;
  }
  else
  {
	  if (OpenDrive(m_hFile, Drivename.c_str()))
	  {
		  m_sfpFatPointer=new sFatPointer[MAX_FATPOINTERS];
		  if (
			  (SetFilePointer(m_hFile,BYTES_PER_SECTOR,NULL,FILE_BEGIN) == BYTES_PER_SECTOR)
			  && 
			  ReadFile(m_hFile,m_sfpFatPointer,FAT_BUFFER_SIZE,&dwBytesRead,NULL)
			  &&
			  dwBytesRead==FAT_BUFFER_SIZE
			  )
			  Okay=true;
	  }
  }
};

CFAT::~CFAT()
{
	if (m_sfpFatPointer)
		delete []m_sfpFatPointer;
	if (m_hFile != INVALID_HANDLE_VALUE)
		CloseHandle(m_hFile);

}


void CFAT::GetClusters(long FatEntry, vector<long>&lvecClusters)
{
	long lIndex=FatEntry;

	*pfsLog << "Dump clusters...";
	*pfsLog << resetiosflags(ios::dec) << setiosflags(ios::hex);
	cout << "Dump clusters...";
	cout << resetiosflags(ios::dec) << setiosflags(ios::hex);
	
	lvecClusters.push_back(FatEntry);
	cout << " " << FatEntry;
	*pfsLog << " " << FatEntry;
	while (lIndex && lIndex < MAX_FATPOINTERS && m_sfpFatPointer[lIndex].uiNextFatPointer != INVALID_POINTER)
	{
		lIndex = m_sfpFatPointer[lIndex].uiNextFatPointer;
		lvecClusters.push_back(lIndex);
		cout << " " << lIndex ; 
		*pfsLog << " " << lIndex;
	}
	cout << endl;
	*pfsLog << endl;
	cout << resetiosflags(ios::hex) ;
	*pfsLog << resetiosflags(ios::hex) ;
}

void CFAT::DumpClusters(ostream* pout, long FatEntry)
{
	long lIndex=FatEntry;
	*pout << resetiosflags(ios::dec) << setiosflags(ios::hex);
	*pout << " " << FatEntry;
	while (lIndex && lIndex < MAX_FATPOINTERS && m_sfpFatPointer[lIndex].uiNextFatPointer != INVALID_POINTER)
	{
		lIndex = m_sfpFatPointer[lIndex].uiNextFatPointer;
		*pout << " " << lIndex;
	}
	*pout << endl;
	*pout << resetiosflags(ios::hex);
}

int CFAT::GetClusters(long * plClusters, long FatEntry)
{
	long lIndex=FatEntry;
	int i (0);
	plClusters[i++] = lIndex;
	while (lIndex && lIndex < MAX_FATPOINTERS && m_sfpFatPointer[lIndex].uiNextFatPointer != INVALID_POINTER)
	{
		lIndex = m_sfpFatPointer[lIndex].uiNextFatPointer;
		plClusters[i++] = lIndex;
	}
	plClusters[i] = INVALID_POINTER;
	return (i);
}

sFatPointer * CFAT::GetFreeFatPointer (__int16 &nThisPointer, __int16 &nNextPointer)
{
	__int16 i, j;
	for (i = 1; i < MAX_FATPOINTERS; i++)
	{
		if (m_sfpFatPointer[i].uiNextFatPointer == 0)   // Leerer Fat-Pointer
		{
			nThisPointer = i;
			break;
		}
	}
	for (j = i+1; j < MAX_FATPOINTERS; j++)
	{
		if (m_sfpFatPointer[j].uiNextFatPointer == 0)   // Leerer Fat-Pointer
		{
			nNextPointer = j;
			break;
		}
	}
	if (i == (__int16) MAX_FATPOINTERS || j == (__int16) MAX_FATPOINTERS)
	{
		nThisPointer = (__int16) INVALID_POINTER;
		nNextPointer = (__int16) INVALID_POINTER;
		return NULL;
	}
	else return &m_sfpFatPointer[nThisPointer];
}


bool CFAT::WriteFatData ()
{
	bool bRet (false);
	DWORD dwBytesWritten;

	if ((SetFilePointer(m_hFile,BYTES_PER_SECTOR,NULL,FILE_BEGIN) == BYTES_PER_SECTOR))
	{ 
		if (WriteFile(m_hFile,m_sfpFatPointer,FAT_BUFFER_SIZE,&dwBytesWritten,NULL))
		{
			if (dwBytesWritten==FAT_BUFFER_SIZE)
			{
				bRet=true;
			}
		}
	}
	return bRet;
}

long CFAT::GetEmergencyClusters(long nFilenumber, int iClustertype)
{
	long i, j (0);
	for (i = 1; i < MAX_FATPOINTERS; i++)
	{
		if (m_sfpFatPointer[i].uiClusterSequenceNumber == 0xFF &&
			m_sfpFatPointer[i].uiClusterType == iClustertype)
		{
			j++;
			if (j == nFilenumber) break;
		}
	}
	return i;			
}

sFatPointer * CFAT::GetFatPointer(int i)
{
	return &m_sfpFatPointer[i];
}
