#ifndef FAT_H
#define FAT_H
#pragma once

#include "general.h"
#include <vector>
#include <string>
#include <iostream>
using namespace std;

#define FAT_BUFFER_SIZE		BYTES_PER_SECTOR * 9
#define MAX_FATPOINTERS		BYTES_PER_SECTOR * 9 / sizeof(sFatPointer)
#define INVALID_POINTER		0xFFFF

struct sFatPointer
{
	unsigned __int16	uiNextFatPointer;			//
	unsigned __int8		uiClusterType;				//FD=Video; FE=Audio
	unsigned __int8		uiClusterSequenceNumber;	//FF=First
};


class CFAT
{
public:
	sFatPointer * GetFatPointer (int i);
	long GetEmergencyClusters (long nFilenumber, int iClustertype);
	bool WriteFatData ();
	int GetClusters(long * plClusters, long FatEntry);
	CFAT(const string &Drivename, bool &Okay);
	~CFAT();
	void GetClusters(long FatEntry, vector<long> &lvecClusters);
	void DumpClusters(ostream* pout, long FatEntry);
	sFatPointer * GetFreeFatPointer (__int16 &nThisPointer, __int16 &nNextPointer);
private:
	HANDLE			m_hFile;
	sFatPointer		*m_sfpFatPointer;
};
#endif