#include "stdafx.h"
#include "general.h"

extern const int BitMasks[8]={0x1, 0x2, 0x4, 0x8, 0x10, 0x20, 0x40, 0x80};
extern const unsigned __int32 ByteMasks[5]={0x0,0xff,0xff00,0xff0000,0xff000000};

bool OpenDrive(HANDLE &hFile, string Drivename)
{
  hFile = CreateFile(Drivename.c_str() , 
    GENERIC_READ | GENERIC_WRITE, 
    FILE_SHARE_READ | FILE_SHARE_WRITE, 
    NULL, 
    OPEN_EXISTING, 
    FILE_FLAG_RANDOM_ACCESS, 
    NULL);
  return (hFile != INVALID_HANDLE_VALUE);
};

bool SetToPhysicalSector(HANDLE &hFile, __int64 i64Sector)
{
  // aus msdn
  LARGE_INTEGER li;

  li.QuadPart = i64Sector*BYTES_PER_SECTOR;
  li.LowPart = SetFilePointer (hFile, li.LowPart, &li.HighPart, FILE_BEGIN);
  if (li.LowPart == INVALID_SET_FILE_POINTER )
  {
    DWORD dwError = GetLastError ();
    if (dwError != NO_ERROR)
    {
      CString s;
      if (FormatMessage
        ( 
        FORMAT_MESSAGE_ALLOCATE_BUFFER | 
        FORMAT_MESSAGE_FROM_SYSTEM | 
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        dwError,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
        s.GetBuffer (255),
        0,
        NULL )
        )
      {
        s.ReleaseBuffer ();
        *pfsLog << s;
        *pfsLog << endl;
      }
      else
      {
        s.ReleaseBuffer ();
      }
      s.Format ("SetToPhysicalSector(%d, %I64) failed",hFile, i64Sector);
      *pfsLog << s;
      *pfsLog << endl;

      return false;
    }
  }
  return true;
}

__int64 i64abs (__int64 i64a, __int64 i64b)
{
  __int64 i64ret;
  i64ret = i64a - i64b;
  if (i64ret < 0) i64ret = -i64ret;
  return i64ret;
}