#ifndef PVR_GENERAL_H
#define PVR_GENERAL_H
#pragma once

#include <windows.h>
#include <string>
#include <fstream>
using namespace std;

#define	VERSION							"v1.0.0"
#define PVRVERSION          "v1.0.0"

#define BYTES_PER_SECTOR				0x200
#define MBYTE							1048576

#define INVALID_SET_FILE_POINTER		((DWORD)-1)

extern const int BitMasks[8];
extern const unsigned __int32 ByteMasks[5];

extern bool    OpenDrive(HANDLE &hFile, const string Drivename);
extern bool    SetToPhysicalSector(HANDLE &hFile, __int64 liSector);
extern __int64 i64abs (__int64 i64a, __int64 i64b);

extern fstream* pfsLog;
extern bool g_bFirmware;


typedef struct SEQ_HEADER_EXT
{
  unsigned extension_start_code : 32 ;
  unsigned extension_start_code_identifier : 4;
  unsigned profile_and_level_indication : 8;
  unsigned progressive_sequence : 1;
  unsigned chroma_format : 2;
  unsigned horizontal_size_extension : 2;
  unsigned vertical_size_extension : 2;
  unsigned bit_rate_extension : 12;
  unsigned marker_bit : 1;
  unsigned vbv_buffer_size_extension : 8;
  unsigned low_delay  : 1;
  unsigned frame_rate_extension_n : 2;
  unsigned frame_rate_extension_d : 5;
}
TSeqHeaderExt;

typedef struct SEQ_HEADER
{
  unsigned sequence_header_code : 32;
  unsigned horizontal_size_value : 12;
  unsigned vertical_size_value : 12;
  unsigned aspect_ratio_information : 4;
  unsigned frame_rate_code : 4;
  unsigned bit_rate_value : 18;
  unsigned marker_bit : 1;
  unsigned vbv_buffer_size_value : 10;
  unsigned constrained_parameters_flag : 1;
  unsigned load_intra_quantiser_matrix : 1;
}
TSeqHeader;

typedef struct JobEntry
{
	BOOL bRipAudioRaw;
	BOOL bRipVideoRaw;
	BOOL bSplitRecording;
	CString sFilename;
	int nIndex;
	double dwOffset;
	double dwRipzeit;
  double fSizeInGB;
	BOOL bMakeBackup;
	BOOL bRestoreBackup;
	BOOL bRipAudio;
	BOOL bRipVideo;
}
TJobEntry;

#endif