#ifndef CBITS_H
#define CBITS_H
#pragma once

#include "general.h"
#include "fat.h"

#define	SECTOR_OFFSET				0x100
#define SECTORS_PER_CLUSTER			0x32000
#define BYTES_PER_CLUSTER			0x6400000
#define BITS_PER_CLUSTER			0x32000000


#define SECTORS_PER_BUFFER			0x80
#define BYTES_PER_BUFFER			0x10000
#define BITS_PER_BUFFER				0x80000


extern CFAT				*g_pfatFAT;

class CIBits
{
	
public:
	int SetPositionRaw (__int64 i64ToPosition);
	CIBits(const string &Drivename,unsigned long FatEntry);
	~CIBits();

	void				BitPointer(unsigned __int64 &ThisValue);
	unsigned __int64	BitPointer();
	bool				ByteAligned();
	void				Get1Bit(unsigned int &Result);
	unsigned int		Get1Bit();
	unsigned __int32	GetBits(unsigned int NumberOfBits);
	void				GetByte(unsigned int &Byte);
	unsigned int 		GetByte();
	void				MoveByte();
	void				MoveBytes(unsigned int NumberOfBytes);
	bool				Rewind();
	bool				EOBS();
  void        ClrEOBS ();
	unsigned __int32	NextBits(unsigned int NumberOfBits);
	unsigned __int32	Next4Bytes();
	bool				SeekTo(unsigned __int64 ToBitPosition);
	vector<long>		m_lvecClusters;
private:

	HANDLE				m_hFile;
	BYTE				*m_bBuffer;
	long				m_lByteIndex;
	long				m_lBitIndex;
	DWORD				m_dwBufferCount;
	long				m_lClusterIndex;
	long				m_lBufferIndex;
	bool				m_bEOBS;

	bool				RefillBuffer();
	inline void			IncByteIndex();
  void Output (const char * s);
};


#endif