#include "stdafx.h"
#include "mpeg.h"
#include <cassert>

/*
const unsigned int VIDEO_STREAM_ID[16]= {0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6,
								0xe7, 0xe8, 0xe9, 0xea, 0xeb, 0xec, 0xed,
								0xee, 0xef};
const unsigned int AUDIO_STREAM_ID[32]= {0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6,
								0xc7, 0xc8, 0xc9, 0xca, 0xcb, 0xcc, 0xcd,
								0xce, 0xcf, 0xd0, 0xd1, 0xd2, 0xd3, 0xd4,
								0xd5, 0xd6, 0xd7, 0xd8, 0xd9, 0xda, 0xdb, 
								0xdc, 0xdd, 0xde, 0xdf};
*/

extern const STREAM_TYPE STREAM_TYPES[0x100]=
{
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, PRIVATE_1, OTHER, PRIVATE_2, 
	// 32 audios
	AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, 
	AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, 
	AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, 
	AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, AUDIO, 
	// 16 Video
	VIDEO, VIDEO ,VIDEO, VIDEO ,VIDEO, VIDEO ,VIDEO, VIDEO,
	VIDEO, VIDEO ,VIDEO, VIDEO ,VIDEO, VIDEO ,VIDEO, VIDEO,
	
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, 
	OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER, OTHER

};


extern inline STREAM_TYPE GetStreamType(unsigned int StreamID)
{
	return STREAM_TYPES[StreamID];
}


bool NextStartCode(CIBits &InStream)
{
	unsigned long		ulByteBuffer;
	while (!InStream.ByteAligned())
		InStream.Get1Bit();
	ulByteBuffer=InStream.GetBits(24);
	while (true)
	{
		if (ulByteBuffer==START_CODE_PREFIX)
		{
			return InStream.SeekTo(InStream.BitPointer()-24);
		}
		if (InStream.EOBS())
			return false;
		ulByteBuffer=((ulByteBuffer & 0x00FFFF) << 8) | InStream.GetByte();
	}
}

bool NextStartCode(CIBits &InStream, unsigned long MaxBytes)
{
	unsigned long		ulByteBuffer;
	while (!InStream.ByteAligned())
		InStream.Get1Bit();
	ulByteBuffer=InStream.GetBits(24);
	MaxBytes -= 2;
	while (MaxBytes--)
	{
		if (ulByteBuffer==START_CODE_PREFIX)
		{
			return InStream.SeekTo(InStream.BitPointer()-24);
		}
		if (InStream.EOBS())
			return false;
		ulByteBuffer=((ulByteBuffer & 0x00FFFF) << 8) | InStream.GetByte();
	}
	return false;
}

  

__int64 IsPES_Packet(CIBits &InStream, unsigned int StreamID, __int32 * pnLength)
{
	CPES_Packet*	pppPES=NULL;

	STREAM_TYPE		stStreamType;
	unsigned int	ui32StartCode=0x00000100 + StreamID;
	unsigned int	uiNext32Bits;
	__int64			i64StreamPTS (0);

	stStreamType=GetStreamType(StreamID);

	if (InStream.Next4Bytes() == ui32StartCode)
	{
		pppPES = new CPES_Packet(&InStream, StreamID);
		if (pppPES->IsOkay())
		{
			if (stStreamType==VIDEO)
			{
				uiNext32Bits=InStream.Next4Bytes();
				if (uiNext32Bits==0x000001B3 || uiNext32Bits == 0x00000100)
				{
					if (pnLength)
						*pnLength = pppPES->PES_Header_Data_Length () + pppPES->PES_Packet_Length ();
					i64StreamPTS = pppPES->PTS ();
				}
			}
			else
			{
				if (pnLength)
					*pnLength = pppPES->PES_Header_Data_Length () + pppPES->PES_Packet_Length ();
				i64StreamPTS = pppPES->PTS ();
			}
		}
	}
	delete pppPES;
	return i64StreamPTS;
}

CPES_Packet::CPES_Packet(CIBits* pbcBitStream, unsigned int uiStreamID)
{
	m_pcbBitStream=pbcBitStream;
	m_uiStreamID=uiStreamID;
	m_Real_PES_Header_Data_Length=0;
	m_bIsOkay=GetPES_Packet();
};

unsigned int CPES_Packet::PES_Packet_Length()
{
	return m_PES_Packet_Length;
}
unsigned int CPES_Packet::PES_Header_Data_Length()
{
	return m_PES_Header_Data_Length;
}
bool CPES_Packet::GetPES_Packet()
{
	unsigned __int64	pos;
	int					i;

	m_pcbBitStream->BitPointer(pos);
	m_pcbBitStream->GetBits(24);
	m_pcbBitStream->GetByte(Stream_ID);
	if (Stream_ID != m_uiStreamID)
	{
		m_pcbBitStream->SeekTo(pos);
		return false;
	}

	m_PES_Packet_Length=m_pcbBitStream->GetBits(16);
	if (m_pcbBitStream->GetBits(2) != 2)
	{
		m_pcbBitStream->SeekTo(pos);
		return false;
	}
	m_pcbBitStream->GetBits(3);
	Data_Alignment_Indicator=m_pcbBitStream->Get1Bit();
	m_pcbBitStream->GetBits(2);

	PTS_DTS_Flags=m_pcbBitStream->GetBits(2);
	m_pcbBitStream->Get1Bit(ESCR_Flag);
	m_pcbBitStream->Get1Bit(ES_Rate_Flag);
	m_pcbBitStream->Get1Bit(DSM_Trick_Mode_Flag);
	m_pcbBitStream->Get1Bit(Additional_Copy_Info_Flag);
	m_pcbBitStream->Get1Bit(PES_CRC_Flag);
	m_pcbBitStream->Get1Bit(PES_Extension_Flag);
	m_pcbBitStream->GetByte(m_PES_Header_Data_Length);


	m_PTS=0;
	m_DTS=0;
	switch (PTS_DTS_Flags)
	{
	case 0:
		// should be possible, but caused some errors...
		m_pcbBitStream->SeekTo(pos);
		return false;
		break;
	case 1:
		m_pcbBitStream->SeekTo(pos);
		return false;
		break;
	case 2:
		m_Real_PES_Header_Data_Length=5;
		// pts
		if (m_pcbBitStream->GetBits(4) != 2)
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}

		PTS_32_30=m_pcbBitStream->GetBits(3);
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}

		PTS_29_15=m_pcbBitStream->GetBits(15);
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}

		PTS_14_00=m_pcbBitStream->GetBits(15);
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}
		m_PTS = ((__int64)PTS_32_30 << 30) + (PTS_29_15 << 15) + PTS_14_00;
		break;
	case 3:
		m_Real_PES_Header_Data_Length=10;
		// pts
		if (m_pcbBitStream->GetBits(4) != 3)
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}

		PTS_32_30=m_pcbBitStream->GetBits(3);
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}

		PTS_29_15=m_pcbBitStream->GetBits(15);
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}

		PTS_14_00=m_pcbBitStream->GetBits(15);
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}
		m_PTS = ((__int64)PTS_32_30 << 30) + (PTS_29_15 << 15) + PTS_14_00;

		// dts
		if (m_pcbBitStream->GetBits(4) != 1)
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}

		DTS_32_30=m_pcbBitStream->GetBits(3);
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}
		DTS_29_15=m_pcbBitStream->GetBits(15);
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}
		DTS_14_00=m_pcbBitStream->GetBits(15);
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}
		m_DTS = ((__int64)DTS_32_30 << 30) + (DTS_29_15 << 15) + DTS_14_00;
		break;
	default:
		m_pcbBitStream->SeekTo(pos);
		return false;
		break;
	}


	if (ESCR_Flag)
	{
		m_Real_PES_Header_Data_Length+=6;
		// 48 bits
		m_pcbBitStream->GetBits(5);
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}
		m_pcbBitStream->GetBits(15);
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}
		m_pcbBitStream->GetBits(15);
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}
		m_pcbBitStream->GetBits(9);
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}
	}
	if (ES_Rate_Flag)
	{
		m_Real_PES_Header_Data_Length+=3;
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}
		m_pcbBitStream->GetBits(22);
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}
	}
	if (DSM_Trick_Mode_Flag)
	{
		m_Real_PES_Header_Data_Length++;
		m_pcbBitStream->MoveByte();
	}
	if (Additional_Copy_Info_Flag)
	{
		if (!m_pcbBitStream->Get1Bit())
		{
			m_pcbBitStream->SeekTo(pos);
			return false;
		}
		m_pcbBitStream->GetBits(7);
		m_Real_PES_Header_Data_Length++;
	}
	if (PES_CRC_Flag)
	{
		m_pcbBitStream->MoveBytes(2);
		m_Real_PES_Header_Data_Length+=2;
	}
	if (PES_Extension_Flag)
	{
		m_Real_PES_Header_Data_Length++; // never had been here... too lazy now...

		m_pcbBitStream->Get1Bit(PES_Private_Data_Flag);
		m_pcbBitStream->Get1Bit(Pack_Header_Field_Tag);
		m_pcbBitStream->Get1Bit(Program_Packet_Sequence_Counter_Flag);
		m_pcbBitStream->Get1Bit(P_STD_Buffer_Flag);
		m_pcbBitStream->GetBits(3);
		m_pcbBitStream->Get1Bit(PES_Extension_Flag_2);

		if (PES_Private_Data_Flag)
		{
			m_pcbBitStream->MoveBytes(16);
		}
		if (Pack_Header_Field_Tag)
		{
			m_pcbBitStream->GetByte(Pack_Field_Length);
			if (!m_Pack_Header.PackHeader(m_pcbBitStream))
			{
				m_pcbBitStream->SeekTo(pos);
				return false;
			}
		}
		if (Program_Packet_Sequence_Counter_Flag)
		{
			if (!m_pcbBitStream->Get1Bit())
			{
				m_pcbBitStream->SeekTo(pos);
				return false;
			}
			m_pcbBitStream->GetBits(7);
			if (!m_pcbBitStream->Get1Bit())
			{
				m_pcbBitStream->SeekTo(pos);
				return false;
			}
			m_pcbBitStream->GetBits(7);
		}
		if (P_STD_Buffer_Flag)
		{
			if (m_pcbBitStream->GetBits(2) != 1)
			{
				m_pcbBitStream->SeekTo(pos);
				return false;
			}
			m_pcbBitStream->GetBits(14);
		}
		if (PES_Extension_Flag_2)
		{
			if (!m_pcbBitStream->Get1Bit())
			{
				m_pcbBitStream->SeekTo(pos);
				return false;
			}
			PES_Extension_Field_Length=m_pcbBitStream->GetBits(7);
			for (i=0;i < (int)PES_Extension_Field_Length;i++)
			{
				m_pcbBitStream->MoveByte();
			}
		}
	}

	if (GetStreamType(Stream_ID)==VIDEO)
		NextStartCode(*m_pcbBitStream);

	//if (GetStreamType(Stream_ID)==AUDIO)
	//	while (m_pcbBitStream->NextBits(8) == 0xFF)
	//		m_pcbBitStream->MoveByte();
		
	//m_pcbBitStream->MoveBytes(PES_Header_Data_Length);

	if (GetStreamType(Stream_ID)==AUDIO && m_Real_PES_Header_Data_Length)
		m_PES_Header_Data_Length=m_Real_PES_Header_Data_Length;
	return true;
};

bool CPES_Packet::IsOkay()
{
	return m_bIsOkay;
}

__int64 CPES_Packet::PTS()
{
	if (m_bIsOkay)
		return m_PTS;
	else
		return -1;
}

__int64 CPES_Packet::DTS()
{
	if (m_bIsOkay && PTS_DTS_Flags==3)
		return m_DTS;
	else
		return -1;
}

bool CPES_Packet::DTS_Available()
{
	return (m_bIsOkay && PTS_DTS_Flags==3);
}
