#ifndef COBITS_H
#define COBITS_H
#pragma once

#include "general.h"

#define OBITS_BUFFER_SIZE		1048576

class COBits
{
	
public:
	COBits(const string &Filename, bool &Okay);
	~COBits();

	bool				ByteAligned();
	void				Put1Bit(const unsigned int Bit);
	void				PutBits(const unsigned __int32 Value, unsigned int NumberOfBits);
	void				PutByte(unsigned int &Byte);
	void				PutByte(const int Byte);
	void				Flush();
  CString &   GetFilename ();
private:

	HANDLE				m_hFile;
	BYTE				*m_bBuffer;
	int					m_iByteIndex;
	int					m_iBitIndex;
	unsigned __int32	m_ui32BitMasks[32];
	void				ClearBuffer();
  CString     m_sFilename;
};


#endif