// Drive.cpp: Implementierung der Klasse CPVRDrive.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "pvrdrive.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CPVRDrive::CPVRDrive(const string &pcDrivename)
{
	*pfsLog << "CPVRDrive::CPVRDrive" << endl;

	CPVRFile*	pcfFile;
	HANDLE		hHandle;
	int			i;
	DWORD		dwBytesRead;
	BOOL		bRet;
	m_pcDrivename=pcDrivename;

	CString s;
//	char buf[0x100*BYTES_PER_SECTOR];
	CFile fDeb;
/*
  if (!fDeb.Open ("driveheader.rec", CFile::modeRead))
  {
    OpenDrive(hHandle,m_pcDrivename);
	  bRet=ReadFile(hHandle, buf,0x100*BYTES_PER_SECTOR,&dwBytesRead,NULL);
	  CloseHandle(hHandle);
	  fDeb.Open ("driveheader.rec", CFile::modeCreate | CFile::modeWrite | CFile::typeBinary);
	  fDeb.Write (buf, 0x100*BYTES_PER_SECTOR);
	  fDeb.Close ();
  }
  else
  {
    fDeb.Close ();
  }
*/
	if (fDeb.Open ("driveheader.rec", CFile::modeRead | CFile::typeBinary))
	{
		fDeb.Read (&m_sDriveHeader, sizeof(m_sDriveHeader));
		fDeb.Close ();
//		OpenDrive(hHandle,m_pcDrivename);
//		bRet=ReadFile(hHandle,buf,sizeof(m_sDriveHeader),&dwBytesRead,NULL);
//		bRet=WriteFile(hHandle, buf,0x100*BYTES_PER_SECTOR,&dwBytesRead,NULL);
//		CloseHandle(hHandle);
	}
  if (m_pcDrivename != "REC")
  {
  	OpenDrive(hHandle,m_pcDrivename);
  	bRet=ReadFile(hHandle,&m_sDriveHeader,sizeof(m_sDriveHeader),&dwBytesRead,NULL);
  	CloseHandle(hHandle);
  }
	

	cout << "TOC shows " << endl
		<< "Files=          " << m_sDriveHeader.iFilesCount << endl
		<< "Used clusters=  " << m_sDriveHeader.iUsedClusters << endl
		<< "Free clusters=  " << m_sDriveHeader.iFreeClusters << endl
		<< endl;
	m_nNumberOfClusters = m_sDriveHeader.iFreeClusters + m_sDriveHeader.iUsedClusters;
	for (i=0;i<m_sDriveHeader.iFilesCount;i++)
	{
		*pfsLog << "reading file " << i << endl;
		pcfFile=new CPVRFile(m_pcDrivename,i);
		m_vcfFiles.push_back(pcfFile);
	}
// Debug 1 mal
/*
	sFileDescription m_sfdFile;
	memset (&m_sfdFile, 0, sizeof (m_sfdFile));
	if (OpenDrive(hHandle, m_pcDrivename))
	{
		for (i = m_sDriveHeader.iFilesCount; i < 100; i++)		
		{
			SetToPhysicalSector(hHandle, TOC_OFFSET_SECTORS + i);
			WriteFile(hHandle, &m_sfdFile,sizeof(m_sfdFile),&dwBytesRead,NULL);
		}
		CloseHandle(hHandle);
	}
	m_sDriveHeader.iFilesCount = 100;
*/
}

CPVRDrive::~CPVRDrive()
{
#ifndef _WINPVR
	*pfsLog << "CPVRDrive::~CPVRDrive()" << endl;
#endif
	while(m_vcfFiles.size())
	{
		delete m_vcfFiles[m_vcfFiles.size()-1];
		m_vcfFiles.pop_back();
	}
}

void CPVRDrive::ListFiles()
{
	int		i;
	for (i=0;i< (int) m_vcfFiles.size();i++)
	{
		m_vcfFiles[i]->Dump(&cout, true);
	}

}

CPVRFile* CPVRDrive::File(const int FileNo)
{
	return m_vcfFiles[FileNo];
}

unsigned __int8 CPVRDrive::FilesCount()
{
	return m_sDriveHeader.iFilesCount;
}
unsigned __int16 CPVRDrive::UsedClusters()
{
	return m_sDriveHeader.iUsedClusters;
}
unsigned __int16 CPVRDrive::FreeClusters()
{
	return m_sDriveHeader.iFreeClusters;
}


bool CPVRDrive::WriteFileData(unsigned __int16 nFilenummer)
{
	return (m_vcfFiles[nFilenummer]->WriteFileData (nFilenummer));
}

__int16 CPVRDrive::GetNewCluster()
{
	if (m_sDriveHeader.iFreeClusters)
	{
		m_sDriveHeader.iFreeClusters--;
		m_sDriveHeader.iUsedClusters++;
		return 1;
	}
	return 0;
}


__int8 CPVRDrive::AddFile(CPVRFile *pvrFile)
{
	if (m_sDriveHeader.iFilesCount < 100)
	{
		m_vcfFiles.push_back(pvrFile);
		m_sDriveHeader.iFilesCount++;
		return m_sDriveHeader.iFilesCount;
	}
	return (-1);
}

bool CPVRDrive::WriteDriveData()
{
	DWORD dwBytesWritten;
	HANDLE hHandle;
	bool bRet;

	OpenDrive(hHandle,m_pcDrivename);
	bRet = (WriteFile(hHandle,&m_sDriveHeader,sizeof(m_sDriveHeader),&dwBytesWritten,NULL) != 0); 
	CloseHandle (hHandle);
	return bRet;
}

string & CPVRDrive::GetDriveName()
{
	return m_pcDrivename;
}

char * CPVRDrive::GetDriveType()
{
	return (m_sDriveHeader.cDrivetype);
}
