// Drive.h: Schnittstelle fr die Klasse CDrive.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DRIVE_H__B0AE57F9_0EB2_436D_88B1_EF086BA76416__INCLUDED_)
#define AFX_DRIVE_H__B0AE57F9_0EB2_436D_88B1_EF086BA76416__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "general.h"
#include "pvrfile.h"
#include <iostream>
#include <vector>
#include <string>
using namespace std;

//#define MAX_FILES		100

struct sDriveHeader
{
	unsigned char		cUnknown1[0x00A];
	unsigned __int16	iUsedClusters;
	unsigned __int16	iFreeClusters;
	unsigned __int8		iFilesCount;
	unsigned char		cUnknown2[25];
	unsigned char		cUnknown2a[8];
	char			    cDrivetype[40];
	unsigned char       cUnknown3[0x1A8];
};

class CPVRDrive  
{
public:
	char * GetDriveType ();
	string & GetDriveName ();
	bool WriteDriveData ();
	__int8 AddFile (CPVRFile * pvrFile);
	__int16 GetNewCluster ();
	bool WriteFileData (unsigned __int16 nFilenummer);
	CPVRFile*			File(const int FileNo);
	void				ListFiles();
						CPVRDrive(const string &pcDrivename);
	virtual				~CPVRDrive();
	unsigned __int8		FilesCount();
	unsigned __int16	UsedClusters();
	unsigned __int16	FreeClusters();

private:
	__int16 m_nNumberOfClusters;
	string				m_pcDrivename;
	vector<CPVRFile*>	m_vcfFiles;
	sDriveHeader		m_sDriveHeader;
};

#endif // !defined(AFX_DRIVE_H__B0AE57F9_0EB2_436D_88B1_EF086BA76416__INCLUDED_)
