#include "stdafx.h"
#include "fat.h"
#include "ibits.h"
#include "obits.h"
#include "mpeg.h"
#include "pvrdrive.h"
//#include <afx.h>
#include <time.h>

//#include <Mmsystem.h>

#include <fstream>
#include <iomanip>
#include <string>
#include <iostream>
using namespace std;

CFAT *g_pfatFAT;
fstream *pfsLog;
bool g_bFirmware;

string	m_cDrivename;
int		m_FileNo;
int		m_Seconds;
int		m_StartSeconds;

void manual()
{
	cout << "Usage:" << endl
		<< "pvrripper dir drivename" << endl
		<< "to get a directory listing" << endl
		<< "example:" << endl
		<< "pvrripper dir g:" << endl
		<< "OR" << endl
		<< "pvrripper rip drivename recordno length_in_seconds" << endl
		<< "to rip a file" << endl
		<< "example:" << endl
		<< "pvrripper rip g: 1 600" << endl
		<< "rips record number 1 from drive g: with a length of 600 seconds" << endl
/*		<< "OR" << endl
		<< "pvrripper rip drivename recordno start_in_seconds length_in_seconds" << endl
		<< "to rip a file" << endl
		<< "example:" << endl
		<< "pvrripper rip g: 7 300 180" << endl
		<< "rips record number 7 from drive g: with a length of 180 seconds" << endl
		<< "starting at second 300" << endl */
		;

	//Sleep(5000);

}


void dir()
{
	bool bResult;
	g_pfatFAT = new CFAT(m_cDrivename,bResult);
	CPVRDrive*	d=new CPVRDrive(m_cDrivename);
	d->ListFiles();
	delete d;
	delete g_pfatFAT;
}
void rip()
{
	bool bResult;
	g_pfatFAT = new CFAT(m_cDrivename,bResult);
	CPVRDrive*	d=new CPVRDrive(m_cDrivename);
	d->File(m_FileNo)->RipStreams(m_StartSeconds,m_Seconds);
	delete d;
	delete g_pfatFAT;
}

void st()
{
	unsigned int i;
	for (i=0;i<0x100;i++)
	{
		switch (GetStreamType(i))
		{
		case AUDIO:
			cout << i << "=AUDIO" << endl;
			break;
		case VIDEO:
			cout << i << "=VIDEO" << endl;
			break;
		case OTHER:
			cout << i << "=OTHER" << endl;
			break;
		case PRIVATE_1:
			cout << i << "=PRIVATE_1" << endl;
			break;
		default:
			cout << i << "=?????" << endl;
			break;
		}
	}
}

int main(int argc , char *argv[])
{

	time_t t;
	time(&t);

	char buf[30];
	tm *thistime;
	thistime=localtime(&t);

	sprintf(buf,"%.4d%.2d%.2d%.2d%.2d%.2d",
		thistime->tm_year+1900,
		thistime->tm_mon+1,
		thistime->tm_mday,
		thistime->tm_hour,
		thistime->tm_min,
		thistime->tm_sec);

	string sLogname=buf + (string)".log";
	//pfsLog = new fstream("rip.log",ios::out);
	//string sLogname=(asctime(thistime));

	pfsLog = new fstream(sLogname.c_str(),ios::out);
	pfsLog->precision(0);
	*pfsLog << "PVRRIPPER LOG " << VERSION << endl;

	int x;
	for (x=0;x<argc;x++)
		*pfsLog << argv[x] << " ";
	*pfsLog << endl;


	if (argc < 3)
	{
		manual();
	}
	else
	{
		m_cDrivename=argv[2];
		if (m_cDrivename.substr(m_cDrivename.length()-1,1) == ":")
		{
			m_cDrivename.insert(0,"\\\\.\\");
		}
		if (!strcmp(argv[1],"dir"))
		{
			if (argc != 3)
			{
				manual();
			}
			dir();
		}
		else if (!strcmp(argv[1],"rip"))
		{
			switch (argc)
			{
			case 5:
				m_FileNo=atol(argv[3]);
				m_Seconds=atol(argv[4]);
				m_StartSeconds=0;
				rip();
				break;
/*			case 6:
				m_FileNo=atol(argv[3]);
				m_StartSeconds=atol(argv[4]);
				m_Seconds=atol(argv[5]);
				rip();
				break; */
			default:
				manual();
				break;
			}
		}
		else
		{
			manual();
		}
	}


	cout << "PVRRipper " << VERSION << endl << endl 
		<< "enjoy using it" << endl	<< endl 
		<< "(c)2001 by Boom" << (char) 7 << endl;

	*pfsLog << "PVRRipper " << VERSION << endl << endl << "(c)2001 by Boom" << endl;

	pfsLog->close();
	delete pfsLog;

	//Sleep(1000);
	return 0;
}
